use strict;
use Test::More tests => 7;
use Data::Dumper;
use Carp qw(croak);
use lib 't';
use testlib;

$Data::Dumper::Indent = 1;

BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  var a = 1 | 2;
};

=for later

??? What should go here?

=cut

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");
isn't($tree, undef, 'JS was parsed successfully');

my @nodes = $tree->findnodes('/AST');
is(scalar @nodes, 1, "AST constructed correctly");

@nodes = $tree->findnodes('/AST/Program');
is(scalar @nodes, 1, "Program is top level node");

@nodes = $tree->findnodes('//BitwiseORExpression');
is(scalar @nodes, 1, "1 Bitwise OR expression found")
  or do { diag Dumper \@nodes; diag $tree->toString };

@nodes = $tree->findnodes('//BitwiseORExpression[.//Number/text() = 1 and .//Number/text() = 2]');
is(scalar @nodes, 1, "1 true bitwise OR expression found")
  or do { diag Dumper \@nodes; diag $tree->toString };


