use strict;
use Test::More tests => 6;
use Data::Dumper;
use Carp qw(croak);
use lib 't';
use testlib;

$Data::Dumper::Indent = 1;

BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  var a = function () {};
  var b = function (p1,p2) {};
  var c = function (p1,p2) { 1; };
  var d = function named(p1,p2) { 1; };
  
  function global_func() {
  };
};

=for later

  var b = new foo;

=cut

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");
isn't($tree, undef, 'JS was parsed successfully');

my @nodes = $tree->findnodes('/AST');
is(scalar @nodes, 1, "AST constructed correctly");

@nodes = $tree->findnodes('/AST/Program');
is(scalar @nodes, 1, "Program is top level node");

@nodes = $tree->findnodes('//FunctionExpression');
is(scalar @nodes, 4, "4 function expressions declared")
  or do { diag $_->toString for $tree->findnodes('//FunctionExpression') };

