use strict;
use Test::More tests => 5;
use Data::Dumper;
BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  // alert();
  function foo() {};
  // more nonsense
};

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");

my @nodes = $tree->findnodes('/AST');
is(scalar @nodes, 1, "AST constructed correctly");

@nodes = $tree->findnodes('/AST/Program');
is(scalar @nodes, 1, "Program is top level node");

@nodes = $tree->findnodes('//FunctionDeclaration');
is(scalar @nodes, 1, "1 function declaration found")
  or do { diag Dumper \@nodes; diag $tree->toString };

