use strict;
use Test::More tests => 6;
use Data::Dumper;
BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  while (1) {
    if (0)
      continue;
      
    if (1)
      continue HERE;
  };
};

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");
isn't($tree,undef,'Got a parse');

my @nodes;

@nodes = $tree->findnodes('//ContinueStatement');
is(scalar @nodes, 2, "2 continue statements found")
  or do { diag $_->toString for $tree->findnodes('//ContinueStatement' ) };

@nodes = $tree->findnodes('//ContinueStatement[./OptionalIdentifier]');
is(scalar @nodes, 1, "1 for statement without a label found")
  or do { diag $_->toString for $tree->findnodes('//ContinueStatement' ) };

@nodes = $tree->findnodes('//ContinueStatement[./Identifier]');
is(scalar @nodes, 1, "1 for statement with a label found")
  or do { diag $_->toString for $tree->findnodes('//ContinueStatement' ) };

