use strict;
use Test::More tests => 6;
use Data::Dumper;
BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  var a;
  
  for (a in 1,2,3) alert(a);

  for (var b in (1,2,3)) alert(b);
};

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");
isn't($tree,undef,'Got a parse');

my @nodes;

@nodes = $tree->findnodes('//ForInStatement');
is(scalar @nodes, 2, "2 for statements found")
  or do { diag $_->toString for $tree->findnodes('//ForInStatement' ) };

@nodes = $tree->findnodes('//ForInStatement[./Identifier/text() = "a"]');
is(scalar @nodes, 1, "1 while statements with expresssion '1' found")
  or do { diag $_->toString for $tree->findnodes('//ForInStatement' ) };

@nodes = $tree->findnodes('//ForInStatement[./VariableDeclarationList]');
is(scalar @nodes, 1, "for statement with inline variable declaration found")
  or do { diag $_->toString for $tree->findnodes('//ForInStatement' ) };

