use strict;
use Test::More tests => 6;
use Data::Dumper;
BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  function a() {
    return;
    return 1;
    return a();
  }
};

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");
isn't($tree,undef,'Got a parse');

my @nodes;

@nodes = $tree->findnodes('//ReturnStatement');
is(scalar @nodes, 3, "3 return statements found")
  or do { diag $_->toString for $tree->findnodes('//ReturnStatement' ) };

@nodes = $tree->findnodes('//ReturnStatement[./EmptyExpression]');
is(scalar @nodes, 1, "1 return statement without an explicit result found")
  or do { diag $_->toString for $tree->findnodes('//ReturnStatement' ) };

@nodes = $tree->findnodes('//ReturnStatement[./Expression]');
is(scalar @nodes, 2, "2 return statements with a result found")
  or do { diag $_->toString for $tree->findnodes('//ReturnStatement' ) };

