use strict;
use Test::More tests => 4;
use Data::Dumper;
BEGIN { use_ok('Javascript::PurePerl') };

my $JS = q{
  try { throw "test"; };
};

my ($parser,$tree);
eval {
  $parser = Javascript::PurePerl->new();
  $tree = $parser->parse( code => $JS );
};
is($@,"","No crash parsing JS");
isn't($tree,undef,'Got a parse');

my @nodes;

@nodes = $tree->findnodes('//TryStatement');
is(scalar @nodes, 1, "1 throw statement found")
  or do { diag $_->toString for $tree->findnodes('//TryStatement' ) };

