####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package Javascript::Grammar;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
use Parse::Yapp::Driver;

#line 1 "lib/Javascript/Grammar.yp"


use strict;
use vars qw($VERSION);
$VERSION = '0.09';

# Parsers for the Little Sublanguages of Javascript
use Text::Balanced qw(gen_delimited_pat);
use Regexp::Common;
use Data::Dumper;

=head1 NAME

Javascript::Grammar - Parse::Yapp grammar for Javascript

=head1 SYNOPSIS

=for example begin
  use strict;
  use Javascript::Grammar;

  my $JS = q{alert('Hello World!'};

  my $parser = Javascript::Grammar->new();
  $parser->YYData->{code} = $JS;
  my $tree = $self->yyparser->YYParse(
                  yylex => \&Javascript::Grammar::yylex,
                  yyerror => sub { $self->error },
                  #yydebug => 0x1F,
             );

=for example end

=head1 DESCRIPTION

This is the grammar for Javascript, oriented at the ECMA
standard. It tries to produce something not entirely unlike
the C<< <autotree> >> directive of Parse::RecDescent.

For better handling of the resulting parse tree, see
L<Javascript::PurePerl>

=head2 EXPORT

None by default.

=cut

sub __prepend {
  my ($self,$item) = @_;
  my %self = @$self;
  unshift @{$self{__ELEMENTS__}}, $item;
  $self;
};

sub __append {
  my ($self,$item) = @_;
  my %self = @$self;
  push @{$self{__ELEMENTS__}}, $item;
  $self;
};

sub __ELEMENTS {
  my ($self,$item) = @_;
  my %self = @$self;
  @{$self{__ELEMENTS__}};
};

=head2 C<list LISTCLASS>

The C<list> keyword is used to declare lists
for the rules. A class that is a C<list> will have
the two methods C<append> and C<prepend>. This is mostly
used to dissolve left- or right-recursion descents.

=cut

sub list($) {
  my $class = shift;
  no strict 'refs';
  *{"${class}::append"} = \&__append;
  *{"${class}::prepend"} = \&__prepend;
  *{"${class}::ELEMENTS"} = \&__ELEMENTS;
};

list 'SourceElements';
list 'StatementList';
list 'FormalParameterList';
list 'ArgumentList';
list 'ElementList';
list 'ArrayLiteral';
list 'ElisionList';
list 'PropertyNameAndValueList';
list 'VariableDeclarationList';
list 'CaseBlock';
list 'CaseClauses';
list 'OptionalCaseClauses';
list 'RegularExpressionFlags';
list 'RegularExpressionBody';

=head2 C<rule RULENAME>

The C<rule> keyword is used to declare the name of the currently
applied rule for easier error diagnosis and better error messages.

It walks the C<caller> chain upwards one step to find the parser.
C<rule> returns C<$_[1]> of the caller, so that the following
code does what you'd expect:

  Rule : SubRule
         { rule "Rule" }
       ;

The name of the current rule is stored as
  $_[0]->YYData->{rule}

=cut

sub rule($) {
  # So we're looking for the first thing that ISA $call_pack
  my @args = DB::uplevel_args(1);

  # First parameter to any rule is the parser:
  $args[0]->YYData->{rule} = shift;

  $args[1];
};

# DB::* Trickery stolen from rubyisms.pm
sub DB::uplevel_args { my @foo = caller($_[0]+1); return @DB::args };

sub value($$) { bless [  __VALUE__ => $_[0] ], $_[1] };

sub AUTOLOAD {
  our $AUTOLOAD;
  return if $AUTOLOAD =~ /DESTROY$/;
  my $code = $AUTOLOAD;
  my $package = __PACKAGE__;
  if ($code =~ /^\Q$package\E::(.*)/) {
    my $class = $1;

    no strict 'refs';
    *{$code} = sub {
      bless [@_], $class
    };
  };

  goto &$code;
};



sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"function" => 62,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -2,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'CallMemberArgs_no_func_lc' => 57,
			'ConditionalExpression_no_func_lc' => 56,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'ExpressionStatement' => 67,
			'BitwiseORExpression_no_func_lc' => 66,
			'NamedFunctionDeclaration' => 20,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'PrimaryExpression_no_lc' => 72,
			'LeftHandSideExpression_no_func_lc' => 71,
			'NullLiteral' => 26,
			'Program' => 27,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'FunctionDeclaration' => 37,
			'ThrowStatement' => 82,
			'EmptyStatement' => 85,
			'PostfixExpression_no_func_lc' => 84,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 89,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'SourceElement' => 46,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'SourceElements' => 53,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 1
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 129,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 2
		DEFAULT => -139
	},
	{#State 3
		DEFAULT => -23
	},
	{#State 4
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'UnaryExpression' => 134,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 5
		DEFAULT => -227
	},
	{#State 6
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -256,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'OptionalExpression' => 136,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'EmptyExpression' => 137,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'AssignmentExpression' => 110,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 138,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 7
		DEFAULT => -233
	},
	{#State 8
		DEFAULT => -86
	},
	{#State 9
		DEFAULT => -17
	},
	{#State 10
		DEFAULT => -141
	},
	{#State 11
		ACTIONS => {
			"%" => 139,
			"*" => 140,
			"/" => 142
		},
		DEFAULT => -155,
		GOTOS => {
			'MultiplicativeOperator' => 141
		}
	},
	{#State 12
		ACTIONS => {
			"-" => 143,
			"+" => 145
		},
		DEFAULT => -162,
		GOTOS => {
			'AdditiveOperator' => 144
		}
	},
	{#State 13
		ACTIONS => {
			"||" => 147,
			"?" => 146
		},
		DEFAULT => -121
	},
	{#State 14
		DEFAULT => -107
	},
	{#State 15
		ACTIONS => {
			">>" => 148,
			">>>" => 150,
			"<<" => 151
		},
		DEFAULT => -173,
		GOTOS => {
			'ShiftOperator' => 149
		}
	},
	{#State 16
		DEFAULT => -109
	},
	{#State 17
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			"," => 155,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -33,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ElisionList' => 152,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Elision' => 153,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'AssignmentExpression' => 154,
			'ConditionalExpression' => 109,
			'UnaryExpression' => 108,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'ArrayLiteral' => 156,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'ElementList' => 157,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 18
		DEFAULT => -231
	},
	{#State 19
		DEFAULT => -236
	},
	{#State 20
		DEFAULT => -12
	},
	{#State 21
		DEFAULT => -54
	},
	{#State 22
		DEFAULT => -298
	},
	{#State 23
		ACTIONS => {
			"(" => 158
		}
	},
	{#State 24
		ACTIONS => {
			"!=" => 162,
			"!==" => 161,
			"===" => 163,
			"==" => 160
		},
		DEFAULT => -189,
		GOTOS => {
			'EqualityOperator' => 159
		}
	},
	{#State 25
		ACTIONS => {
			"[" => 164,
			"(" => 166,
			"." => 167
		},
		DEFAULT => -97,
		GOTOS => {
			'Arguments' => 165
		}
	},
	{#State 26
		DEFAULT => -24
	},
	{#State 27
		ACTIONS => {
			'' => 168
		}
	},
	{#State 28
		DEFAULT => -134
	},
	{#State 29
		ACTIONS => {
			":" => 169
		},
		DEFAULT => -27
	},
	{#State 30
		ACTIONS => {
			"&&" => 170
		},
		DEFAULT => -213
	},
	{#State 31
		ACTIONS => {
			";" => 172,
			"," => 171
		}
	},
	{#State 32
		ACTIONS => {
			"(" => 173
		}
	},
	{#State 33
		ACTIONS => {
			"&" => 174
		},
		DEFAULT => -195
	},
	{#State 34
		ACTIONS => {
			'IDENTIFIER' => 65,
			"new" => 177,
			'NULL' => 77,
			'BOOLEAN' => 91,
			"{" => 116,
			'REGEX' => 22,
			"this" => 80,
			'STRING' => 38,
			"(" => 73,
			"[" => 17,
			"function" => 121,
			'NUMBER' => 42
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'Boolean' => 35,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'MemberExpression_no_func_lc' => 178,
			'MemberIndexExpression_no_func_lc' => 14,
			'MemberExpression' => 179,
			'ObjectLiteral' => 120,
			'NewMemberExpression_no_func_lc' => 175,
			'NumericLiteral' => 63,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 176,
			'StringLiteral' => 48,
			'MemberMemberExpression_no_func_lc' => 69,
			'PrimaryExpression_no_lc' => 180,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 35
		DEFAULT => -19
	},
	{#State 36
		DEFAULT => -138
	},
	{#State 37
		DEFAULT => -6
	},
	{#State 38
		DEFAULT => -295
	},
	{#State 39
		ACTIONS => {
			"(" => 181
		}
	},
	{#State 40
		DEFAULT => -228
	},
	{#State 41
		DEFAULT => -232
	},
	{#State 42
		DEFAULT => -294
	},
	{#State 43
		DEFAULT => -230
	},
	{#State 44
		DEFAULT => -268
	},
	{#State 45
		ACTIONS => {
			"typeof" => 55,
			"}" => 182,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'CallIdentifier_no_func_lc' => 88,
			'Statement' => 184,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'StatementList' => 183,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 46
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"function" => 62,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -3,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'NamedFunctionDeclaration' => 20,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'FunctionDeclaration' => 37,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 89,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'SourceElement' => 46,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'SourceElements' => 185,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 47
		ACTIONS => {
			"(" => 186
		}
	},
	{#State 48
		DEFAULT => -22
	},
	{#State 49
		ACTIONS => {
			"{" => 45
		},
		GOTOS => {
			'Block' => 187
		}
	},
	{#State 50
		DEFAULT => -266
	},
	{#State 51
		DEFAULT => -234
	},
	{#State 52
		DEFAULT => -25
	},
	{#State 53
		DEFAULT => -1
	},
	{#State 54
		DEFAULT => -133
	},
	{#State 55
		DEFAULT => -135
	},
	{#State 56
		DEFAULT => -60
	},
	{#State 57
		DEFAULT => -84
	},
	{#State 58
		DEFAULT => -18
	},
	{#State 59
		DEFAULT => -140
	},
	{#State 60
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		DEFAULT => -291,
		GOTOS => {
			'OptionalIdentifier' => 189,
			'Identifier' => 188
		}
	},
	{#State 61
		ACTIONS => {
			"[" => 190,
			"(" => 166,
			"." => 192
		},
		DEFAULT => -115,
		GOTOS => {
			'Arguments' => 191
		}
	},
	{#State 62
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 193
		}
	},
	{#State 63
		DEFAULT => -21
	},
	{#State 64
		DEFAULT => -137
	},
	{#State 65
		DEFAULT => -293
	},
	{#State 66
		ACTIONS => {
			"|" => 194
		},
		DEFAULT => -207
	},
	{#State 67
		DEFAULT => -226
	},
	{#State 68
		DEFAULT => -267
	},
	{#State 69
		DEFAULT => -108
	},
	{#State 70
		ACTIONS => {
			"(" => 195
		}
	},
	{#State 71
		ACTIONS => {
			"*=" => 196,
			"|=" => 197,
			"&=" => 203,
			"--" => 204,
			"-=" => 205,
			"/=" => 206,
			"<<=" => 199,
			"%=" => 207,
			"^=" => 200,
			">>=" => 201,
			"++" => 208,
			"=" => 210,
			"+=" => 209,
			">>>=" => 202
		},
		DEFAULT => -129,
		GOTOS => {
			'PostfixOperator' => 211,
			'AssignmentOperator' => 198
		}
	},
	{#State 72
		DEFAULT => -106
	},
	{#State 73
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 212,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 74
		DEFAULT => -224
	},
	{#State 75
		ACTIONS => {
			"^" => 213
		},
		DEFAULT => -201
	},
	{#State 76
		DEFAULT => -223
	},
	{#State 77
		DEFAULT => -297
	},
	{#State 78
		DEFAULT => -251
	},
	{#State 79
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		DEFAULT => -291,
		GOTOS => {
			'OptionalIdentifier' => 214,
			'Identifier' => 188
		}
	},
	{#State 80
		DEFAULT => -26
	},
	{#State 81
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 215,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 82
		DEFAULT => -235
	},
	{#State 83
		DEFAULT => -136
	},
	{#State 84
		DEFAULT => -142
	},
	{#State 85
		DEFAULT => -225
	},
	{#State 86
		ACTIONS => {
			"<" => 216,
			">=" => 218,
			"in" => 222,
			"instanceof" => 219,
			"<=" => 220,
			">" => 221
		},
		DEFAULT => -183,
		GOTOS => {
			'RelationalOperator' => 223,
			'RelationalOperatorNoIn' => 217
		}
	},
	{#State 87
		DEFAULT => -149
	},
	{#State 88
		DEFAULT => -87
	},
	{#State 89
		DEFAULT => -5
	},
	{#State 90
		DEFAULT => -28
	},
	{#State 91
		DEFAULT => -296
	},
	{#State 92
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'VariableDeclaration' => 226,
			'Identifier' => 224,
			'VariableDeclarationList' => 225
		}
	},
	{#State 93
		DEFAULT => -96
	},
	{#State 94
		DEFAULT => -229
	},
	{#State 95
		DEFAULT => -265
	},
	{#State 96
		DEFAULT => -20
	},
	{#State 97
		DEFAULT => -29
	},
	{#State 98
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'UnaryExpression' => 227,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 99
		ACTIONS => {
			"<" => 216,
			">=" => 218,
			"in" => 222,
			"instanceof" => 219,
			"<=" => 220,
			">" => 221
		},
		DEFAULT => -187,
		GOTOS => {
			'RelationalOperator' => 228,
			'RelationalOperatorNoIn' => 217
		}
	},
	{#State 100
		ACTIONS => {
			"%" => 139,
			"*" => 140,
			"/" => 142
		},
		DEFAULT => -157,
		GOTOS => {
			'MultiplicativeOperator' => 229
		}
	},
	{#State 101
		DEFAULT => -88
	},
	{#State 102
		ACTIONS => {
			"[" => 230,
			"(" => 166,
			"." => 232
		},
		DEFAULT => -99,
		GOTOS => {
			'Arguments' => 231
		}
	},
	{#State 103
		DEFAULT => -111
	},
	{#State 104
		DEFAULT => -13
	},
	{#State 105
		DEFAULT => -114
	},
	{#State 106
		ACTIONS => {
			"&&" => 233
		},
		DEFAULT => -217
	},
	{#State 107
		DEFAULT => -110
	},
	{#State 108
		DEFAULT => -151
	},
	{#State 109
		DEFAULT => -64
	},
	{#State 110
		DEFAULT => -58
	},
	{#State 111
		DEFAULT => -27
	},
	{#State 112
		ACTIONS => {
			"&" => 234
		},
		DEFAULT => -199
	},
	{#State 113
		ACTIONS => {
			'IDENTIFIER' => 65,
			"new" => 235,
			'NULL' => 77,
			'BOOLEAN' => 91,
			"{" => 116,
			'REGEX' => 22,
			"this" => 80,
			'STRING' => 38,
			"(" => 73,
			"[" => 17,
			"function" => 121,
			'NUMBER' => 42
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'Boolean' => 35,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'MemberExpression' => 236,
			'ObjectLiteral' => 120,
			'NumericLiteral' => 63,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 176,
			'StringLiteral' => 48,
			'NullLiteral' => 26,
			'PrimaryExpression_no_lc' => 123,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 114
		DEFAULT => -98
	},
	{#State 115
		DEFAULT => -90
	},
	{#State 116
		ACTIONS => {
			"}" => 237,
			'IDENTIFIER' => 65,
			'NUMBER' => 42,
			'STRING' => 38
		},
		GOTOS => {
			'String' => 58,
			'StringLiteral' => 240,
			'PropertyName' => 241,
			'Number' => 9,
			'PropertyNameAndValueList' => 239,
			'Identifier' => 238,
			'PropertyPair' => 243,
			'NumericLiteral' => 242
		}
	},
	{#State 117
		ACTIONS => {
			">>" => 148,
			">>>" => 150,
			"<<" => 151
		},
		DEFAULT => -177,
		GOTOS => {
			'ShiftOperator' => 244
		}
	},
	{#State 118
		DEFAULT => -112
	},
	{#State 119
		ACTIONS => {
			"[" => 245,
			"(" => 166,
			"." => 247
		},
		DEFAULT => -118,
		GOTOS => {
			'Arguments' => 246
		}
	},
	{#State 120
		DEFAULT => -32
	},
	{#State 121
		ACTIONS => {
			"(" => 248,
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 193
		}
	},
	{#State 122
		ACTIONS => {
			"^" => 249
		},
		DEFAULT => -205
	},
	{#State 123
		DEFAULT => -31
	},
	{#State 124
		ACTIONS => {
			"||" => 251,
			"?" => 250
		},
		DEFAULT => -125
	},
	{#State 125
		ACTIONS => {
			"*=" => 196,
			"|=" => 197,
			"&=" => 203,
			"--" => 204,
			"-=" => 205,
			"/=" => 206,
			"<<=" => 199,
			"%=" => 207,
			"^=" => 200,
			">>=" => 201,
			"++" => 208,
			"=" => 210,
			"+=" => 209,
			">>>=" => 202
		},
		DEFAULT => -131,
		GOTOS => {
			'PostfixOperator' => 253,
			'AssignmentOperator' => 252
		}
	},
	{#State 126
		ACTIONS => {
			"==" => 160,
			"!=" => 162,
			"!==" => 161,
			"===" => 163
		},
		DEFAULT => -193,
		GOTOS => {
			'EqualityOperator' => 254
		}
	},
	{#State 127
		DEFAULT => -91
	},
	{#State 128
		ACTIONS => {
			"|" => 255
		},
		DEFAULT => -211
	},
	{#State 129
		ACTIONS => {
			";" => 257,
			"," => 256
		}
	},
	{#State 130
		DEFAULT => -113
	},
	{#State 131
		DEFAULT => -144
	},
	{#State 132
		DEFAULT => -14
	},
	{#State 133
		ACTIONS => {
			"-" => 143,
			"+" => 145
		},
		DEFAULT => -164,
		GOTOS => {
			'AdditiveOperator' => 258
		}
	},
	{#State 134
		DEFAULT => -143
	},
	{#State 135
		ACTIONS => {
			"++" => 208,
			"--" => 204
		},
		DEFAULT => -131,
		GOTOS => {
			'PostfixOperator' => 253
		}
	},
	{#State 136
		ACTIONS => {
			";" => 259
		}
	},
	{#State 137
		DEFAULT => -260
	},
	{#State 138
		ACTIONS => {
			"," => 256
		},
		DEFAULT => -259
	},
	{#State 139
		DEFAULT => -148
	},
	{#State 140
		DEFAULT => -146
	},
	{#State 141
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'UnaryExpression' => 260,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 142
		DEFAULT => -147
	},
	{#State 143
		DEFAULT => -154
	},
	{#State 144
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 261,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 145
		DEFAULT => -153
	},
	{#State 146
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 262,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 147
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 263,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 148
		DEFAULT => -160
	},
	{#State 149
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'AdditiveExpression' => 264,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 150
		DEFAULT => -161
	},
	{#State 151
		DEFAULT => -159
	},
	{#State 152
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			"," => 155,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -34,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Elision' => 265,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 266,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 153
		DEFAULT => -43
	},
	{#State 154
		DEFAULT => -39
	},
	{#State 155
		DEFAULT => -45
	},
	{#State 156
		ACTIONS => {
			"]" => 267
		}
	},
	{#State 157
		ACTIONS => {
			"," => 268
		},
		DEFAULT => -35
	},
	{#State 158
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 269,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 159
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 270,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'ShiftExpression' => 117,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 160
		DEFAULT => -179
	},
	{#State 161
		DEFAULT => -182
	},
	{#State 162
		DEFAULT => -180
	},
	{#State 163
		DEFAULT => -181
	},
	{#State 164
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 271,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 165
		DEFAULT => -85
	},
	{#State 166
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -93,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'ArgumentList' => 273,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'AssignmentExpression' => 272,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 167
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 274
		}
	},
	{#State 168
		DEFAULT => 0
	},
	{#State 169
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 275,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 170
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 276,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 171
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 34,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'AdditiveExpression_no_func_lc' => 12,
			'LogicalORExpression_no_func_lc' => 13,
			'MemberIndexExpression_no_func_lc' => 14,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'BitwiseORExpression_no_func_lc' => 66,
			'AssignmentExpression_no_func_lc' => 277,
			'EqualityExpression_no_func_lc' => 24,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'Identifier' => 111,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'PostfixExpression_no_func_lc' => 84,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'CallIdentifier_no_func_lc' => 88,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'StringLiteral' => 48,
			'Null' => 96,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 172
		DEFAULT => -240
	},
	{#State 173
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 278,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 174
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 279,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 175
		DEFAULT => -109
	},
	{#State 176
		DEFAULT => -114
	},
	{#State 177
		ACTIONS => {
			'IDENTIFIER' => 65,
			"new" => 177,
			'NULL' => 77,
			'BOOLEAN' => 91,
			"{" => 116,
			'REGEX' => 22,
			"this" => 80,
			'STRING' => 38,
			"(" => 73,
			"[" => 17,
			"function" => 121,
			'NUMBER' => 42
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'Boolean' => 35,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'MemberExpression_no_func_lc' => 178,
			'MemberIndexExpression_no_func_lc' => 14,
			'MemberExpression' => 280,
			'ObjectLiteral' => 120,
			'NewMemberExpression_no_func_lc' => 175,
			'NumericLiteral' => 63,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 176,
			'StringLiteral' => 48,
			'MemberMemberExpression_no_func_lc' => 69,
			'PrimaryExpression_no_lc' => 180,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 178
		ACTIONS => {
			"(" => 166,
			"[" => 190,
			"." => 192
		},
		GOTOS => {
			'Arguments' => 281
		}
	},
	{#State 179
		ACTIONS => {
			"[" => 245,
			"." => 247
		},
		DEFAULT => -116
	},
	{#State 180
		DEFAULT => -31
	},
	{#State 181
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 282,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 182
		DEFAULT => -237
	},
	{#State 183
		ACTIONS => {
			"}" => 283
		}
	},
	{#State 184
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -221,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'CallIdentifier_no_func_lc' => 88,
			'Statement' => 184,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'StatementList' => 284,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 185
		DEFAULT => -4
	},
	{#State 186
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 285,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 187
		ACTIONS => {
			"catch" => 288
		},
		DEFAULT => -286,
		GOTOS => {
			'Catch' => 286,
			'OptionalCatch' => 287
		}
	},
	{#State 188
		DEFAULT => -292
	},
	{#State 189
		ACTIONS => {
			";" => 289
		}
	},
	{#State 190
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 290,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 191
		DEFAULT => -78
	},
	{#State 192
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 291
		}
	},
	{#State 193
		ACTIONS => {
			"(" => 292
		}
	},
	{#State 194
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 293,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 195
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			"var" => 306,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -256,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'EmptyExpression' => 294,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'ExpressionNoIn' => 301,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'ConditionalExpressionNoIn' => 296,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 303,
			'AssignmentExpressionNoIn' => 302,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'LogicalORExpressionNoIn' => 298,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 307,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'OptionalExpressionNoIn' => 308,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 196
		DEFAULT => -67
	},
	{#State 197
		DEFAULT => -77
	},
	{#State 198
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 309,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 199
		DEFAULT => -72
	},
	{#State 200
		DEFAULT => -76
	},
	{#State 201
		DEFAULT => -73
	},
	{#State 202
		DEFAULT => -74
	},
	{#State 203
		DEFAULT => -75
	},
	{#State 204
		DEFAULT => -128
	},
	{#State 205
		DEFAULT => -71
	},
	{#State 206
		DEFAULT => -68
	},
	{#State 207
		DEFAULT => -69
	},
	{#State 208
		DEFAULT => -127
	},
	{#State 209
		DEFAULT => -70
	},
	{#State 210
		DEFAULT => -66
	},
	{#State 211
		DEFAULT => -130
	},
	{#State 212
		ACTIONS => {
			"," => 256,
			")" => 310
		}
	},
	{#State 213
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 311,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 214
		ACTIONS => {
			";" => 312
		}
	},
	{#State 215
		ACTIONS => {
			"while" => 313
		}
	},
	{#State 216
		DEFAULT => -166
	},
	{#State 217
		DEFAULT => -171
	},
	{#State 218
		DEFAULT => -169
	},
	{#State 219
		DEFAULT => -170
	},
	{#State 220
		DEFAULT => -168
	},
	{#State 221
		DEFAULT => -167
	},
	{#State 222
		DEFAULT => -172
	},
	{#State 223
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'ShiftExpression' => 314,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 224
		ACTIONS => {
			"=" => 316
		},
		DEFAULT => -248,
		GOTOS => {
			'Initializer' => 315
		}
	},
	{#State 225
		ACTIONS => {
			";" => 317
		}
	},
	{#State 226
		ACTIONS => {
			"," => 318
		},
		DEFAULT => -243
	},
	{#State 227
		DEFAULT => -145
	},
	{#State 228
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'ShiftExpression' => 319,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 229
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'UnaryExpression' => 320,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 230
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 321,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 231
		DEFAULT => -89
	},
	{#State 232
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 322
		}
	},
	{#State 233
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 323,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 234
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 324,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 235
		ACTIONS => {
			'IDENTIFIER' => 65,
			"new" => 235,
			'NULL' => 77,
			'BOOLEAN' => 91,
			"{" => 116,
			'REGEX' => 22,
			"this" => 80,
			'STRING' => 38,
			"(" => 73,
			"[" => 17,
			"function" => 121,
			'NUMBER' => 42
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'Boolean' => 35,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'Number' => 9,
			'MemberExpression' => 280,
			'ObjectLiteral' => 120,
			'NumericLiteral' => 63,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 176,
			'StringLiteral' => 48,
			'NullLiteral' => 26,
			'PrimaryExpression_no_lc' => 123,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'Identifier' => 111,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 236
		ACTIONS => {
			"[" => 245,
			"(" => 166,
			"." => 247
		},
		DEFAULT => -120,
		GOTOS => {
			'Arguments' => 325
		}
	},
	{#State 237
		DEFAULT => -47
	},
	{#State 238
		DEFAULT => -51
	},
	{#State 239
		ACTIONS => {
			"}" => 326,
			"," => 327
		}
	},
	{#State 240
		DEFAULT => -52
	},
	{#State 241
		ACTIONS => {
			":" => 328
		}
	},
	{#State 242
		DEFAULT => -53
	},
	{#State 243
		DEFAULT => -49
	},
	{#State 244
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'AdditiveExpression' => 329,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 245
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 330,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 246
		DEFAULT => -79
	},
	{#State 247
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 331
		}
	},
	{#State 248
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		DEFAULT => -7,
		GOTOS => {
			'FormalParameterList' => 333,
			'Identifier' => 332
		}
	},
	{#State 249
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 334,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 250
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 335,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 251
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 336,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 252
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 337,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 253
		DEFAULT => -132
	},
	{#State 254
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 338,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'ShiftExpression' => 117,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 255
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 339,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 256
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 340,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 257
		DEFAULT => -283
	},
	{#State 258
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'LeftHandSideExpression' => 135,
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'Boolean' => 35,
			'NewExpression' => 114,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 341,
			'Number' => 9,
			'CallIdentifier' => 127,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallIndex' => 115,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Literal' => 90,
			'NamedFunctionDeclaration' => 104,
			'MemberMemberExpression' => 130,
			'NewMemberExpression' => 105,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 259
		DEFAULT => -271
	},
	{#State 260
		DEFAULT => -150
	},
	{#State 261
		ACTIONS => {
			"%" => 139,
			"*" => 140,
			"/" => 142
		},
		DEFAULT => -156,
		GOTOS => {
			'MultiplicativeOperator' => 229
		}
	},
	{#State 262
		ACTIONS => {
			":" => 342
		}
	},
	{#State 263
		ACTIONS => {
			"&&" => 233
		},
		DEFAULT => -214
	},
	{#State 264
		ACTIONS => {
			"-" => 143,
			"+" => 145
		},
		DEFAULT => -163,
		GOTOS => {
			'AdditiveOperator' => 258
		}
	},
	{#State 265
		DEFAULT => -44
	},
	{#State 266
		DEFAULT => -40
	},
	{#State 267
		DEFAULT => -38
	},
	{#State 268
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			"," => 155,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -36,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ElisionList' => 343,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'Elision' => 344,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 345,
			'Identifier' => 111,
			'ConditionalExpression' => 109,
			'UnaryExpression' => 108,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 269
		ACTIONS => {
			"," => 256,
			")" => 346
		}
	},
	{#State 270
		ACTIONS => {
			"<" => 216,
			">=" => 218,
			"in" => 222,
			"instanceof" => 219,
			"<=" => 220,
			">" => 221
		},
		DEFAULT => -184,
		GOTOS => {
			'RelationalOperator' => 228,
			'RelationalOperatorNoIn' => 217
		}
	},
	{#State 271
		ACTIONS => {
			"," => 256,
			"]" => 347
		}
	},
	{#State 272
		DEFAULT => -94
	},
	{#State 273
		ACTIONS => {
			"," => 348,
			")" => 349
		}
	},
	{#State 274
		DEFAULT => -82
	},
	{#State 275
		DEFAULT => -282
	},
	{#State 276
		ACTIONS => {
			"|" => 255
		},
		DEFAULT => -208
	},
	{#State 277
		DEFAULT => -55
	},
	{#State 278
		ACTIONS => {
			"," => 256,
			")" => 350
		}
	},
	{#State 279
		ACTIONS => {
			"!=" => 162,
			"!==" => 161,
			"===" => 163,
			"==" => 160
		},
		DEFAULT => -190,
		GOTOS => {
			'EqualityOperator' => 254
		}
	},
	{#State 280
		ACTIONS => {
			"(" => 166,
			"[" => 245,
			"." => 247
		},
		GOTOS => {
			'Arguments' => 325
		}
	},
	{#State 281
		DEFAULT => -101
	},
	{#State 282
		ACTIONS => {
			"," => 256,
			")" => 351
		}
	},
	{#State 283
		DEFAULT => -238
	},
	{#State 284
		DEFAULT => -222
	},
	{#State 285
		ACTIONS => {
			"," => 256,
			")" => 352
		}
	},
	{#State 286
		DEFAULT => -285
	},
	{#State 287
		ACTIONS => {
			"finally" => 354
		},
		DEFAULT => -289,
		GOTOS => {
			'OptionalFinally' => 355,
			'Finally' => 353
		}
	},
	{#State 288
		ACTIONS => {
			"(" => 356
		}
	},
	{#State 289
		DEFAULT => -270
	},
	{#State 290
		ACTIONS => {
			"," => 256,
			"]" => 357
		}
	},
	{#State 291
		DEFAULT => -104
	},
	{#State 292
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		DEFAULT => -7,
		GOTOS => {
			'FormalParameterList' => 358,
			'Identifier' => 332
		}
	},
	{#State 293
		ACTIONS => {
			"^" => 249
		},
		DEFAULT => -202
	},
	{#State 294
		DEFAULT => -258
	},
	{#State 295
		ACTIONS => {
			"^" => 359
		},
		DEFAULT => -203
	},
	{#State 296
		DEFAULT => -62
	},
	{#State 297
		ACTIONS => {
			"!=" => 162,
			"!==" => 161,
			"===" => 163,
			"==" => 160
		},
		DEFAULT => -191,
		GOTOS => {
			'EqualityOperator' => 360
		}
	},
	{#State 298
		ACTIONS => {
			"||" => 362,
			"?" => 361
		},
		DEFAULT => -123
	},
	{#State 299
		ACTIONS => {
			">>" => 148,
			">>>" => 150,
			"<<" => 151
		},
		DEFAULT => -175,
		GOTOS => {
			'ShiftOperator' => 244
		}
	},
	{#State 300
		ACTIONS => {
			"|" => 363
		},
		DEFAULT => -209
	},
	{#State 301
		ACTIONS => {
			"," => 364
		},
		DEFAULT => -257
	},
	{#State 302
		DEFAULT => -56
	},
	{#State 303
		ACTIONS => {
			"*=" => 196,
			"|=" => 197,
			"&=" => 203,
			"--" => 204,
			"-=" => 205,
			"/=" => 206,
			"<<=" => 199,
			"%=" => 207,
			"^=" => 200,
			">>=" => 201,
			"++" => 208,
			"in" => 366,
			"=" => 210,
			"+=" => 209,
			">>>=" => 202
		},
		DEFAULT => -131,
		GOTOS => {
			'PostfixOperator' => 253,
			'AssignmentOperator' => 365
		}
	},
	{#State 304
		ACTIONS => {
			"<" => 216,
			">=" => 218,
			"instanceof" => 219,
			"<=" => 220,
			">" => 221
		},
		DEFAULT => -185,
		GOTOS => {
			'RelationalOperatorNoIn' => 367
		}
	},
	{#State 305
		ACTIONS => {
			"&" => 368
		},
		DEFAULT => -197
	},
	{#State 306
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'VariableDeclarationNoIn' => 370,
			'Identifier' => 369,
			'VariableDeclarationListNoIn' => 371
		}
	},
	{#State 307
		ACTIONS => {
			"&&" => 372
		},
		DEFAULT => -215
	},
	{#State 308
		ACTIONS => {
			";" => 373
		}
	},
	{#State 309
		DEFAULT => -61
	},
	{#State 310
		DEFAULT => -30
	},
	{#State 311
		ACTIONS => {
			"&" => 234
		},
		DEFAULT => -196
	},
	{#State 312
		DEFAULT => -269
	},
	{#State 313
		ACTIONS => {
			"(" => 374
		}
	},
	{#State 314
		ACTIONS => {
			">>" => 148,
			">>>" => 150,
			"<<" => 151
		},
		DEFAULT => -174,
		GOTOS => {
			'ShiftOperator' => 244
		}
	},
	{#State 315
		DEFAULT => -247
	},
	{#State 316
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 375,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 317
		DEFAULT => -239
	},
	{#State 318
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'VariableDeclaration' => 226,
			'Identifier' => 224,
			'VariableDeclarationList' => 376
		}
	},
	{#State 319
		ACTIONS => {
			">>" => 148,
			">>>" => 150,
			"<<" => 151
		},
		DEFAULT => -178,
		GOTOS => {
			'ShiftOperator' => 244
		}
	},
	{#State 320
		DEFAULT => -152
	},
	{#State 321
		ACTIONS => {
			"," => 256,
			"]" => 377
		}
	},
	{#State 322
		DEFAULT => -83
	},
	{#State 323
		ACTIONS => {
			"|" => 255
		},
		DEFAULT => -212
	},
	{#State 324
		ACTIONS => {
			"==" => 160,
			"!=" => 162,
			"!==" => 161,
			"===" => 163
		},
		DEFAULT => -194,
		GOTOS => {
			'EqualityOperator' => 254
		}
	},
	{#State 325
		DEFAULT => -100
	},
	{#State 326
		DEFAULT => -46
	},
	{#State 327
		ACTIONS => {
			'IDENTIFIER' => 65,
			'NUMBER' => 42,
			'STRING' => 38
		},
		GOTOS => {
			'Number' => 9,
			'String' => 58,
			'Identifier' => 238,
			'PropertyPair' => 378,
			'StringLiteral' => 240,
			'NumericLiteral' => 242,
			'PropertyName' => 241
		}
	},
	{#State 328
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 379,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 329
		ACTIONS => {
			"-" => 143,
			"+" => 145
		},
		DEFAULT => -165,
		GOTOS => {
			'AdditiveOperator' => 258
		}
	},
	{#State 330
		ACTIONS => {
			"," => 256,
			"]" => 380
		}
	},
	{#State 331
		DEFAULT => -105
	},
	{#State 332
		DEFAULT => -8
	},
	{#State 333
		ACTIONS => {
			"," => 381,
			")" => 382
		}
	},
	{#State 334
		ACTIONS => {
			"&" => 234
		},
		DEFAULT => -200
	},
	{#State 335
		ACTIONS => {
			":" => 383
		}
	},
	{#State 336
		ACTIONS => {
			"&&" => 233
		},
		DEFAULT => -218
	},
	{#State 337
		DEFAULT => -65
	},
	{#State 338
		ACTIONS => {
			"<" => 216,
			">=" => 218,
			"in" => 222,
			"instanceof" => 219,
			"<=" => 220,
			">" => 221
		},
		DEFAULT => -188,
		GOTOS => {
			'RelationalOperator' => 228,
			'RelationalOperatorNoIn' => 217
		}
	},
	{#State 339
		ACTIONS => {
			"^" => 249
		},
		DEFAULT => -206
	},
	{#State 340
		DEFAULT => -59
	},
	{#State 341
		ACTIONS => {
			"%" => 139,
			"*" => 140,
			"/" => 142
		},
		DEFAULT => -158,
		GOTOS => {
			'MultiplicativeOperator' => 229
		}
	},
	{#State 342
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 384,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 343
		ACTIONS => {
			"," => 155
		},
		DEFAULT => -37,
		GOTOS => {
			'Elision' => 265
		}
	},
	{#State 344
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -43,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 385,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 345
		DEFAULT => -41
	},
	{#State 346
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 386,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 347
		DEFAULT => -80
	},
	{#State 348
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 387,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 349
		DEFAULT => -92
	},
	{#State 350
		ACTIONS => {
			"{" => 389
		},
		GOTOS => {
			'CaseBlock' => 388
		}
	},
	{#State 351
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 390,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 352
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 391,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 353
		DEFAULT => -288
	},
	{#State 354
		ACTIONS => {
			"{" => 45
		},
		GOTOS => {
			'Block' => 392
		}
	},
	{#State 355
		DEFAULT => -284
	},
	{#State 356
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 393
		}
	},
	{#State 357
		DEFAULT => -102
	},
	{#State 358
		ACTIONS => {
			"," => 381,
			")" => 394
		}
	},
	{#State 359
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 395,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 360
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 396,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'ShiftExpression' => 299,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 361
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'ConditionalExpressionNoIn' => 296,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 397,
			'AssignmentExpressionNoIn' => 398,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'LogicalORExpressionNoIn' => 298,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 307,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 362
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 399,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 363
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'BitwiseXORExpressionNoIn' => 400,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 364
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'ConditionalExpressionNoIn' => 296,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 397,
			'AssignmentExpressionNoIn' => 401,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'LogicalORExpressionNoIn' => 298,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 307,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 365
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'ConditionalExpressionNoIn' => 296,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 397,
			'AssignmentExpressionNoIn' => 402,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'LogicalORExpressionNoIn' => 298,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 307,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 366
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 403,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 367
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'ShiftExpression' => 404,
			'AnonymousFunctionDeclaration' => 132,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 368
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'EqualityExpressionNoIn' => 405,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'StringLiteral' => 48,
			'PostfixExpression' => 131,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 369
		ACTIONS => {
			"=" => 406
		},
		DEFAULT => -246,
		GOTOS => {
			'InitializerNoIn' => 407
		}
	},
	{#State 370
		ACTIONS => {
			"," => 408
		},
		DEFAULT => -241
	},
	{#State 371
		ACTIONS => {
			";" => 409,
			"in" => 410
		}
	},
	{#State 372
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 411,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 135,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 373
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -256,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'OptionalExpression' => 412,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'EmptyExpression' => 137,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'AssignmentExpression' => 110,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 138,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 374
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 413,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 375
		DEFAULT => -250
	},
	{#State 376
		DEFAULT => -244
	},
	{#State 377
		DEFAULT => -81
	},
	{#State 378
		DEFAULT => -50
	},
	{#State 379
		DEFAULT => -48
	},
	{#State 380
		DEFAULT => -103
	},
	{#State 381
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'Identifier' => 414
		}
	},
	{#State 382
		ACTIONS => {
			"{" => 415
		}
	},
	{#State 383
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'AssignmentExpression' => 416,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'Identifier' => 111,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 384
		DEFAULT => -122
	},
	{#State 385
		DEFAULT => -42
	},
	{#State 386
		DEFAULT => -272
	},
	{#State 387
		DEFAULT => -95
	},
	{#State 388
		DEFAULT => -273
	},
	{#State 389
		ACTIONS => {
			"case" => 417
		},
		DEFAULT => -276,
		GOTOS => {
			'CaseClauses' => 419,
			'OptionalCaseClauses' => 418,
			'CaseClause' => 420
		}
	},
	{#State 390
		ACTIONS => {
			"else" => 421
		},
		DEFAULT => -253
	},
	{#State 391
		DEFAULT => -255
	},
	{#State 392
		DEFAULT => -290
	},
	{#State 393
		ACTIONS => {
			")" => 422
		}
	},
	{#State 394
		ACTIONS => {
			"{" => 423
		}
	},
	{#State 395
		ACTIONS => {
			"&" => 368
		},
		DEFAULT => -198
	},
	{#State 396
		ACTIONS => {
			"<" => 216,
			">=" => 218,
			"instanceof" => 219,
			"<=" => 220,
			">" => 221
		},
		DEFAULT => -186,
		GOTOS => {
			'RelationalOperatorNoIn' => 367
		}
	},
	{#State 397
		ACTIONS => {
			"*=" => 196,
			"|=" => 197,
			"&=" => 203,
			"--" => 204,
			"-=" => 205,
			"/=" => 206,
			"<<=" => 199,
			"%=" => 207,
			"^=" => 200,
			">>=" => 201,
			"++" => 208,
			"=" => 210,
			"+=" => 209,
			">>>=" => 202
		},
		DEFAULT => -131,
		GOTOS => {
			'PostfixOperator' => 253,
			'AssignmentOperator' => 365
		}
	},
	{#State 398
		ACTIONS => {
			":" => 424
		}
	},
	{#State 399
		ACTIONS => {
			"&&" => 372
		},
		DEFAULT => -216
	},
	{#State 400
		ACTIONS => {
			"^" => 359
		},
		DEFAULT => -204
	},
	{#State 401
		DEFAULT => -57
	},
	{#State 402
		DEFAULT => -63
	},
	{#State 403
		ACTIONS => {
			"," => 256,
			")" => 425
		}
	},
	{#State 404
		ACTIONS => {
			">>" => 148,
			">>>" => 150,
			"<<" => 151
		},
		DEFAULT => -176,
		GOTOS => {
			'ShiftOperator' => 244
		}
	},
	{#State 405
		ACTIONS => {
			"!=" => 162,
			"!==" => 161,
			"===" => 163,
			"==" => 160
		},
		DEFAULT => -192,
		GOTOS => {
			'EqualityOperator' => 360
		}
	},
	{#State 406
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'ConditionalExpressionNoIn' => 296,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 397,
			'AssignmentExpressionNoIn' => 426,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'LogicalORExpressionNoIn' => 298,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 307,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 407
		DEFAULT => -245
	},
	{#State 408
		ACTIONS => {
			'IDENTIFIER' => 65
		},
		GOTOS => {
			'VariableDeclarationNoIn' => 370,
			'Identifier' => 369,
			'VariableDeclarationListNoIn' => 427
		}
	},
	{#State 409
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -256,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'OptionalExpression' => 428,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'EmptyExpression' => 137,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'AssignmentExpression' => 110,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 138,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 410
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 429,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 411
		ACTIONS => {
			"|" => 363
		},
		DEFAULT => -210
	},
	{#State 412
		ACTIONS => {
			";" => 430
		}
	},
	{#State 413
		ACTIONS => {
			"," => 256,
			")" => 431
		}
	},
	{#State 414
		DEFAULT => -9
	},
	{#State 415
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"function" => 62,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -16,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'NamedFunctionDeclaration' => 20,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'FunctionDeclaration' => 37,
			'ThrowStatement' => 82,
			'FunctionBody' => 433,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 89,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'SourceElement' => 46,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'SourceElements' => 432,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 416
		DEFAULT => -126
	},
	{#State 417
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'AssignmentExpression' => 110,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 434,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 418
		ACTIONS => {
			"}" => 435,
			"default" => 436
		},
		GOTOS => {
			'DefaultClause' => 437
		}
	},
	{#State 419
		ACTIONS => {
			"case" => 417
		},
		DEFAULT => -277,
		GOTOS => {
			'CaseClause' => 438
		}
	},
	{#State 420
		DEFAULT => -278
	},
	{#State 421
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 439,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 422
		ACTIONS => {
			"{" => 45
		},
		GOTOS => {
			'Block' => 440
		}
	},
	{#State 423
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"function" => 62,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -16,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'NamedFunctionDeclaration' => 20,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'FunctionDeclaration' => 37,
			'ThrowStatement' => 82,
			'FunctionBody' => 441,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 89,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'SourceElement' => 46,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'SourceElements' => 432,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 424
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'BitwiseORExpressionNoIn' => 300,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpressionNoIn' => 295,
			'NewMemberExpression' => 105,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'UnaryExpression' => 108,
			'Identifier' => 111,
			'ConditionalExpressionNoIn' => 296,
			'EqualityExpressionNoIn' => 297,
			'LeftHandSideExpression' => 397,
			'AssignmentExpressionNoIn' => 442,
			'NewExpression' => 114,
			'Boolean' => 35,
			'RelationalExpressionNoIn' => 304,
			'LogicalORExpressionNoIn' => 298,
			'CallIdentifier' => 127,
			'CallIndex' => 115,
			'BitwiseANDExpressionNoIn' => 305,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'LogicalANDExpressionNoIn' => 307,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 299,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 425
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 443,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 426
		DEFAULT => -249
	},
	{#State 427
		DEFAULT => -242
	},
	{#State 428
		ACTIONS => {
			";" => 444
		}
	},
	{#State 429
		ACTIONS => {
			"," => 256,
			")" => 445
		}
	},
	{#State 430
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -256,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'OptionalExpression' => 446,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'EmptyExpression' => 137,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'AssignmentExpression' => 110,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 138,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 431
		ACTIONS => {
			";" => 447
		}
	},
	{#State 432
		DEFAULT => -15
	},
	{#State 433
		ACTIONS => {
			"}" => 448
		}
	},
	{#State 434
		ACTIONS => {
			":" => 449,
			"," => 256
		}
	},
	{#State 435
		DEFAULT => -274
	},
	{#State 436
		ACTIONS => {
			":" => 450
		}
	},
	{#State 437
		ACTIONS => {
			"case" => 417
		},
		DEFAULT => -276,
		GOTOS => {
			'CaseClauses' => 419,
			'OptionalCaseClauses' => 451,
			'CaseClause' => 420
		}
	},
	{#State 438
		DEFAULT => -279
	},
	{#State 439
		DEFAULT => -252
	},
	{#State 440
		DEFAULT => -287
	},
	{#State 441
		ACTIONS => {
			"}" => 452
		}
	},
	{#State 442
		DEFAULT => -124
	},
	{#State 443
		DEFAULT => -263
	},
	{#State 444
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"new" => 113,
			'NULL' => 77,
			"~" => 59,
			"+" => 36,
			"this" => 80,
			'STRING' => 38,
			"++" => 83,
			"!" => 10,
			"function" => 121,
			"[" => 17,
			'NUMBER' => 42,
			"--" => 64,
			'IDENTIFIER' => 65,
			'BOOLEAN' => 91,
			'REGEX' => 22,
			"{" => 116,
			"(" => 73,
			"void" => 28,
			"delete" => 54
		},
		DEFAULT => -256,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 98,
			'OptionalExpression' => 453,
			'RelationalExpression' => 99,
			'String' => 58,
			'MemberIndexExpression' => 118,
			'MultiplicativeExpression' => 100,
			'Number' => 9,
			'EmptyExpression' => 137,
			'ObjectLiteral' => 120,
			'MemberExpression' => 119,
			'CallMemberArgs' => 101,
			'NumericLiteral' => 63,
			'CallExpression' => 102,
			'FunctionExpression' => 103,
			'NamedFunctionDeclaration' => 104,
			'BitwiseXORExpression' => 122,
			'NewMemberExpression' => 105,
			'LogicalANDExpression' => 106,
			'PrimaryExpression_no_lc' => 123,
			'NullLiteral' => 26,
			'PrimaryExpression' => 107,
			'Identifier' => 111,
			'AssignmentExpression' => 110,
			'UnaryExpression' => 108,
			'ConditionalExpression' => 109,
			'LogicalORExpression' => 124,
			'LeftHandSideExpression' => 125,
			'BitwiseANDExpression' => 112,
			'NewExpression' => 114,
			'Boolean' => 35,
			'EqualityExpression' => 126,
			'CallIdentifier' => 127,
			'BitwiseORExpression' => 128,
			'CallIndex' => 115,
			'Expression' => 138,
			'Literal' => 90,
			'MemberMemberExpression' => 130,
			'PostfixExpression' => 131,
			'StringLiteral' => 48,
			'AnonymousFunctionDeclaration' => 132,
			'ShiftExpression' => 117,
			'Null' => 96,
			'AdditiveExpression' => 133,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 445
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 454,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 446
		ACTIONS => {
			")" => 455
		}
	},
	{#State 447
		DEFAULT => -254
	},
	{#State 448
		DEFAULT => -11
	},
	{#State 449
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -220,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'OptionalStatementList' => 457,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'CallIdentifier_no_func_lc' => 88,
			'Statement' => 184,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'StatementList' => 456,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 450
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			"var" => 92,
			'BOOLEAN' => 91,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		DEFAULT => -220,
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'OptionalStatementList' => 458,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'CallIdentifier_no_func_lc' => 88,
			'Statement' => 184,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'StatementList' => 456,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 451
		ACTIONS => {
			"}" => 459
		}
	},
	{#State 452
		DEFAULT => -10
	},
	{#State 453
		ACTIONS => {
			")" => 460
		}
	},
	{#State 454
		DEFAULT => -264
	},
	{#State 455
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 461,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 456
		DEFAULT => -219
	},
	{#State 457
		DEFAULT => -280
	},
	{#State 458
		DEFAULT => -281
	},
	{#State 459
		DEFAULT => -275
	},
	{#State 460
		ACTIONS => {
			"typeof" => 55,
			"-" => 2,
			"throw" => 1,
			"~" => 59,
			"return" => 6,
			"break" => 60,
			"!" => 10,
			"[" => 17,
			"--" => 64,
			'IDENTIFIER' => 65,
			'REGEX' => 22,
			"with" => 23,
			"for" => 70,
			"(" => 73,
			"void" => 28,
			"switch" => 32,
			"new" => 34,
			'NULL' => 77,
			"+" => 36,
			";" => 78,
			"continue" => 79,
			"this" => 80,
			'STRING' => 38,
			"do" => 81,
			"if" => 39,
			"++" => 83,
			'NUMBER' => 42,
			'BOOLEAN' => 91,
			"var" => 92,
			"{" => 45,
			"while" => 47,
			"try" => 49,
			"delete" => 54
		},
		GOTOS => {
			'BooleanLiteral' => 3,
			'UnaryPrefixOperator' => 4,
			'ConditionalExpression_no_func_lc' => 56,
			'CallMemberArgs_no_func_lc' => 57,
			'String' => 58,
			'IfStatement' => 5,
			'LabelledStatement' => 7,
			'CallIndex_no_func_lc' => 8,
			'Number' => 9,
			'MultiplicativeExpression_no_func_lc' => 11,
			'MemberExpression_no_func_lc' => 61,
			'MemberIndexExpression_no_func_lc' => 14,
			'LogicalORExpression_no_func_lc' => 13,
			'AdditiveExpression_no_func_lc' => 12,
			'NewMemberExpression_no_func_lc' => 16,
			'ShiftExpression_no_func_lc' => 15,
			'NumericLiteral' => 63,
			'ReturnStatement' => 18,
			'TryStatement' => 19,
			'BitwiseORExpression_no_func_lc' => 66,
			'ExpressionStatement' => 67,
			'AssignmentExpression_no_func_lc' => 21,
			'EqualityExpression_no_func_lc' => 24,
			'CForStatement' => 68,
			'MemberMemberExpression_no_func_lc' => 69,
			'CallExpression_no_func_lc' => 25,
			'LeftHandSideExpression_no_func_lc' => 71,
			'PrimaryExpression_no_lc' => 72,
			'NullLiteral' => 26,
			'VariableStatement' => 74,
			'Identifier' => 29,
			'BitwiseXORExpression_no_func_lc' => 75,
			'LogicalANDExpression_no_func_lc' => 30,
			'Expression_no_func_lc' => 31,
			'Block' => 76,
			'BitwiseANDExpression_no_func_lc' => 33,
			'Boolean' => 35,
			'ThrowStatement' => 82,
			'PostfixExpression_no_func_lc' => 84,
			'EmptyStatement' => 85,
			'IterationStatement' => 40,
			'RelationalExpression_no_func_lc' => 86,
			'UnaryExpression_no_func_lc' => 87,
			'WithStatement' => 41,
			'Statement' => 462,
			'CallIdentifier_no_func_lc' => 88,
			'BreakStatement' => 43,
			'Literal' => 90,
			'NewExpression_no_func_lc' => 93,
			'ForInStatement' => 44,
			'StringLiteral' => 48,
			'ContinueStatement' => 94,
			'DoStatement' => 95,
			'WhileStatement' => 50,
			'Null' => 96,
			'SwitchStatement' => 51,
			'RegularExpressionLiteral' => 52,
			'ArrayLiteralContainer' => 97
		}
	},
	{#State 461
		DEFAULT => -261
	},
	{#State 462
		DEFAULT => -262
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'Program', 1,
sub
#line 161 "lib/Javascript/Grammar.yp"
{ Program( SourceElements => $_[1] ) }
	],
	[#Rule 2
		 'Program', 0,
sub
#line 162 "lib/Javascript/Grammar.yp"
{ Program() }
	],
	[#Rule 3
		 'SourceElements', 1,
sub
#line 165 "lib/Javascript/Grammar.yp"
{ SourceElements( __ELEMENTS__ => [ $_[1] ] )}
	],
	[#Rule 4
		 'SourceElements', 2,
sub
#line 166 "lib/Javascript/Grammar.yp"
{ $_[2]->prepend( $_[1] ) }
	],
	[#Rule 5
		 'SourceElement', 1, undef
	],
	[#Rule 6
		 'SourceElement', 1, undef
	],
	[#Rule 7
		 'FormalParameterList', 0,
sub
#line 173 "lib/Javascript/Grammar.yp"
{ FormalParameterList( __ELEMENTS__ => [] ) }
	],
	[#Rule 8
		 'FormalParameterList', 1,
sub
#line 174 "lib/Javascript/Grammar.yp"
{ FormalParameterList( __ELEMENTS__ => [ $_[1] ] ) }
	],
	[#Rule 9
		 'FormalParameterList', 3,
sub
#line 175 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[3] ) }
	],
	[#Rule 10
		 'NamedFunctionDeclaration', 8,
sub
#line 180 "lib/Javascript/Grammar.yp"
{ NamedFunctionDeclaration( FunctionName => $_[2], FormalParameterList => $_[4], FunctionBody => $_[7] ) }
	],
	[#Rule 11
		 'AnonymousFunctionDeclaration', 7,
sub
#line 185 "lib/Javascript/Grammar.yp"
{ AnonymousFunctionDeclaration( FormalParameterList => $_[3], FunctionBody => $_[6] ) }
	],
	[#Rule 12
		 'FunctionDeclaration', 1,
sub
#line 188 "lib/Javascript/Grammar.yp"
{ FunctionDeclaration( Function => $_[1] ) }
	],
	[#Rule 13
		 'FunctionExpression', 1,
sub
#line 192 "lib/Javascript/Grammar.yp"
{ FunctionExpression( Function => $_[1] ) }
	],
	[#Rule 14
		 'FunctionExpression', 1,
sub
#line 193 "lib/Javascript/Grammar.yp"
{ FunctionExpression( Function => $_[1] ) }
	],
	[#Rule 15
		 'FunctionBody', 1,
sub
#line 196 "lib/Javascript/Grammar.yp"
{ FunctionBody( SourceElements => $_[1] ) }
	],
	[#Rule 16
		 'FunctionBody', 0,
sub
#line 197 "lib/Javascript/Grammar.yp"
{ FunctionBody( ) }
	],
	[#Rule 17
		 'NumericLiteral', 1, undef
	],
	[#Rule 18
		 'StringLiteral', 1, undef
	],
	[#Rule 19
		 'BooleanLiteral', 1, undef
	],
	[#Rule 20
		 'NullLiteral', 1, undef
	],
	[#Rule 21
		 'Literal', 1, undef
	],
	[#Rule 22
		 'Literal', 1, undef
	],
	[#Rule 23
		 'Literal', 1, undef
	],
	[#Rule 24
		 'Literal', 1, undef
	],
	[#Rule 25
		 'Literal', 1, undef
	],
	[#Rule 26
		 'PrimaryExpression_no_lc', 1,
sub
#line 225 "lib/Javascript/Grammar.yp"
{ value $_[1], 'PrimaryExpression' }
	],
	[#Rule 27
		 'PrimaryExpression_no_lc', 1, undef
	],
	[#Rule 28
		 'PrimaryExpression_no_lc', 1, undef
	],
	[#Rule 29
		 'PrimaryExpression_no_lc', 1, undef
	],
	[#Rule 30
		 'PrimaryExpression_no_lc', 3,
sub
#line 229 "lib/Javascript/Grammar.yp"
{ $_[2] }
	],
	[#Rule 31
		 'PrimaryExpression', 1, undef
	],
	[#Rule 32
		 'PrimaryExpression', 1, undef
	],
	[#Rule 33
		 'ArrayLiteral', 0,
sub
#line 240 "lib/Javascript/Grammar.yp"
{ ArrayLiteral( __ELEMENTS__ => [] ) }
	],
	[#Rule 34
		 'ArrayLiteral', 1,
sub
#line 241 "lib/Javascript/Grammar.yp"
{ ArrayLiteral( __ELEMENTS__ => [ $_[1] ] ) }
	],
	[#Rule 35
		 'ArrayLiteral', 1,
sub
#line 242 "lib/Javascript/Grammar.yp"
{ ArrayLiteral( __ELEMENTS__ => [ $_[1] ] ) }
	],
	[#Rule 36
		 'ArrayLiteral', 2,
sub
#line 243 "lib/Javascript/Grammar.yp"
{ ArrayLiteral( __ELEMENTS__ => [ $_[1] ] ) }
	],
	[#Rule 37
		 'ArrayLiteral', 3,
sub
#line 244 "lib/Javascript/Grammar.yp"
{ ArrayLiteral( __ELEMENTS__ => [ $_[1] ] )->append( $_[3] ) }
	],
	[#Rule 38
		 'ArrayLiteralContainer', 3,
sub
#line 247 "lib/Javascript/Grammar.yp"
{ $_[2] }
	],
	[#Rule 39
		 'ElementList', 1,
sub
#line 250 "lib/Javascript/Grammar.yp"
{ ElementList( __ELEMENTS__ => [ $_[1] ]) }
	],
	[#Rule 40
		 'ElementList', 2,
sub
#line 251 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[2] ) }
	],
	[#Rule 41
		 'ElementList', 3,
sub
#line 252 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[3] ) }
	],
	[#Rule 42
		 'ElementList', 4,
sub
#line 253 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[3] )->append( $_[4] ) }
	],
	[#Rule 43
		 'ElisionList', 1,
sub
#line 257 "lib/Javascript/Grammar.yp"
{ ElisionList( __ELEMENTS__ => [ $_[1] ] ) }
	],
	[#Rule 44
		 'ElisionList', 2,
sub
#line 258 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[2] ) }
	],
	[#Rule 45
		 'Elision', 1,
sub
#line 262 "lib/Javascript/Grammar.yp"
{ bless [ ], 'Elision' }
	],
	[#Rule 46
		 'ObjectLiteral', 3,
sub
#line 266 "lib/Javascript/Grammar.yp"
{ ObjectLiteral( Properties => $_[2] )}
	],
	[#Rule 47
		 'ObjectLiteral', 2,
sub
#line 267 "lib/Javascript/Grammar.yp"
{ ObjectLiteral() }
	],
	[#Rule 48
		 'PropertyPair', 3,
sub
#line 271 "lib/Javascript/Grammar.yp"
{ PropertyPair( Name => $_[1], Value => $_[3])}
	],
	[#Rule 49
		 'PropertyNameAndValueList', 1,
sub
#line 275 "lib/Javascript/Grammar.yp"
{ PropertyNameAndValueList( __ELEMENTS__ => [ $_[1] ] ) }
	],
	[#Rule 50
		 'PropertyNameAndValueList', 3,
sub
#line 276 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[3] ) }
	],
	[#Rule 51
		 'PropertyName', 1,
sub
#line 280 "lib/Javascript/Grammar.yp"
{ PropertyName( Value => $_[1] ) }
	],
	[#Rule 52
		 'PropertyName', 1,
sub
#line 281 "lib/Javascript/Grammar.yp"
{ PropertyName( Value => $_[1] ) }
	],
	[#Rule 53
		 'PropertyName', 1,
sub
#line 282 "lib/Javascript/Grammar.yp"
{ PropertyName( Value => $_[1] ) }
	],
	[#Rule 54
		 'Expression_no_func_lc', 1,
sub
#line 287 "lib/Javascript/Grammar.yp"
{ Expression( AssignmentExpression => $_[1] ) }
	],
	[#Rule 55
		 'Expression_no_func_lc', 3,
sub
#line 289 "lib/Javascript/Grammar.yp"
{ Expression( Expression => $_[1], AssignmentExpression => $_[3] )}
	],
	[#Rule 56
		 'ExpressionNoIn', 1,
sub
#line 294 "lib/Javascript/Grammar.yp"
{ Expression( AssignmentExpression => $_[1] ) }
	],
	[#Rule 57
		 'ExpressionNoIn', 3,
sub
#line 296 "lib/Javascript/Grammar.yp"
{ Expression( Expression => $_[1], AssignmentExpression => $_[3] ) }
	],
	[#Rule 58
		 'Expression', 1,
sub
#line 300 "lib/Javascript/Grammar.yp"
{ Expression( AssignmentExpression => $_[1] ) }
	],
	[#Rule 59
		 'Expression', 3,
sub
#line 301 "lib/Javascript/Grammar.yp"
{ Expression( Expression => $_[1], AssignmentExpression => $_[3] )}
	],
	[#Rule 60
		 'AssignmentExpression_no_func_lc', 1, undef
	],
	[#Rule 61
		 'AssignmentExpression_no_func_lc', 3,
sub
#line 307 "lib/Javascript/Grammar.yp"
{ AssignmentExpression(
                                      lhs      => $_[1],
                                      operator => $_[2],
                                      rhs      => $_[3] )}
	],
	[#Rule 62
		 'AssignmentExpressionNoIn', 1, undef
	],
	[#Rule 63
		 'AssignmentExpressionNoIn', 3,
sub
#line 316 "lib/Javascript/Grammar.yp"
{ AssignmentExpression(
                                      lhs      => $_[1],
                                      operator => $_[2],
                                      rhs      => $_[3] )}
	],
	[#Rule 64
		 'AssignmentExpression', 1, undef
	],
	[#Rule 65
		 'AssignmentExpression', 3,
sub
#line 325 "lib/Javascript/Grammar.yp"
{ AssignmentExpression(
                                      lhs      => $_[1],
                                      operator => $_[2],
                                      rhs      => $_[3] )}
	],
	[#Rule 66
		 'AssignmentOperator', 1,
sub
#line 331 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 67
		 'AssignmentOperator', 1,
sub
#line 332 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 68
		 'AssignmentOperator', 1,
sub
#line 333 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 69
		 'AssignmentOperator', 1,
sub
#line 334 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 70
		 'AssignmentOperator', 1,
sub
#line 335 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 71
		 'AssignmentOperator', 1,
sub
#line 336 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 72
		 'AssignmentOperator', 1,
sub
#line 337 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 73
		 'AssignmentOperator', 1,
sub
#line 338 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 74
		 'AssignmentOperator', 1,
sub
#line 339 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 75
		 'AssignmentOperator', 1,
sub
#line 340 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 76
		 'AssignmentOperator', 1,
sub
#line 341 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 77
		 'AssignmentOperator', 1,
sub
#line 342 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AssignmentOperator' }
	],
	[#Rule 78
		 'CallMemberArgs_no_func_lc', 2,
sub
#line 346 "lib/Javascript/Grammar.yp"
{ CallMemberArgs( Callee => $_[1], Arguments => $_[2] ) }
	],
	[#Rule 79
		 'CallMemberArgs', 2,
sub
#line 350 "lib/Javascript/Grammar.yp"
{ CallMemberArgs( Callee => $_[1], Arguments => $_[2] ) }
	],
	[#Rule 80
		 'CallIndex_no_func_lc', 4,
sub
#line 354 "lib/Javascript/Grammar.yp"
{ CallIndex( Callee => $_[1], IndexExpression => $_[3] )}
	],
	[#Rule 81
		 'CallIndex', 4,
sub
#line 358 "lib/Javascript/Grammar.yp"
{ CallIndex( Callee => $_[1], IndexExpression => $_[3] )}
	],
	[#Rule 82
		 'CallIdentifier_no_func_lc', 3,
sub
#line 362 "lib/Javascript/Grammar.yp"
{ bless [  Callee => $_[1], Member => $_[3] ], 'CallIdentifier' }
	],
	[#Rule 83
		 'CallIdentifier', 3,
sub
#line 366 "lib/Javascript/Grammar.yp"
{ bless [  Callee => $_[1], Member => $_[3] ], 'CallIdentifier' }
	],
	[#Rule 84
		 'CallExpression_no_func_lc', 1, undef
	],
	[#Rule 85
		 'CallExpression_no_func_lc', 2, undef
	],
	[#Rule 86
		 'CallExpression_no_func_lc', 1, undef
	],
	[#Rule 87
		 'CallExpression_no_func_lc', 1, undef
	],
	[#Rule 88
		 'CallExpression', 1, undef
	],
	[#Rule 89
		 'CallExpression', 2, undef
	],
	[#Rule 90
		 'CallExpression', 1, undef
	],
	[#Rule 91
		 'CallExpression', 1, undef
	],
	[#Rule 92
		 'Arguments', 3,
sub
#line 384 "lib/Javascript/Grammar.yp"
{ $_[2] }
	],
	[#Rule 93
		 'ArgumentList', 0,
sub
#line 388 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => []        ], 'ArgumentList' }
	],
	[#Rule 94
		 'ArgumentList', 1,
sub
#line 389 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [ $_[1] ] ], 'ArgumentList' }
	],
	[#Rule 95
		 'ArgumentList', 3,
sub
#line 390 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[3] ) }
	],
	[#Rule 96
		 'LeftHandSideExpression_no_func_lc', 1, undef
	],
	[#Rule 97
		 'LeftHandSideExpression_no_func_lc', 1, undef
	],
	[#Rule 98
		 'LeftHandSideExpression', 1, undef
	],
	[#Rule 99
		 'LeftHandSideExpression', 1, undef
	],
	[#Rule 100
		 'NewMemberExpression', 3,
sub
#line 404 "lib/Javascript/Grammar.yp"
{ NewMemberExpression( ClassExpression => $_[2], Arguments => $_[3] ) }
	],
	[#Rule 101
		 'NewMemberExpression_no_func_lc', 3,
sub
#line 407 "lib/Javascript/Grammar.yp"
{ NewMemberExpression( ClassExpression => $_[2], Arguments => $_[3] ) }
	],
	[#Rule 102
		 'MemberIndexExpression_no_func_lc', 4,
sub
#line 411 "lib/Javascript/Grammar.yp"
{ MemberIndexExpression( lhs => $_[1],  IndexExpression => $_[3] ) }
	],
	[#Rule 103
		 'MemberIndexExpression', 4,
sub
#line 415 "lib/Javascript/Grammar.yp"
{ MemberIndexExpression( lhs => $_[1],  IndexExpression => $_[3] ) }
	],
	[#Rule 104
		 'MemberMemberExpression_no_func_lc', 3,
sub
#line 420 "lib/Javascript/Grammar.yp"
{ MemberMemberExpression( lhs => $_[1], member => $_[3] ) }
	],
	[#Rule 105
		 'MemberMemberExpression', 3,
sub
#line 424 "lib/Javascript/Grammar.yp"
{ MemberMemberExpression( lhs => $_[1], member => $_[3] ) }
	],
	[#Rule 106
		 'MemberExpression_no_func_lc', 1, undef
	],
	[#Rule 107
		 'MemberExpression_no_func_lc', 1, undef
	],
	[#Rule 108
		 'MemberExpression_no_func_lc', 1, undef
	],
	[#Rule 109
		 'MemberExpression_no_func_lc', 1, undef
	],
	[#Rule 110
		 'MemberExpression', 1, undef
	],
	[#Rule 111
		 'MemberExpression', 1, undef
	],
	[#Rule 112
		 'MemberExpression', 1, undef
	],
	[#Rule 113
		 'MemberExpression', 1, undef
	],
	[#Rule 114
		 'MemberExpression', 1, undef
	],
	[#Rule 115
		 'NewExpression_no_func_lc', 1, undef
	],
	[#Rule 116
		 'NewExpression_no_func_lc', 2,
sub
#line 445 "lib/Javascript/Grammar.yp"
{ NewExpression( Class => $_[2] )}
	],
	[#Rule 117
		 'NewExpression_no_func_lc', 1, undef
	],
	[#Rule 118
		 'NewExpression', 1, undef
	],
	[#Rule 119
		 'NewExpression', 1, undef
	],
	[#Rule 120
		 'NewExpression', 2,
sub
#line 452 "lib/Javascript/Grammar.yp"
{ NewExpression( Class => $_[2] )}
	],
	[#Rule 121
		 'ConditionalExpression_no_func_lc', 1, undef
	],
	[#Rule 122
		 'ConditionalExpression_no_func_lc', 5,
sub
#line 459 "lib/Javascript/Grammar.yp"
{ ConditionalExpression(
                                             expression => $_[1],
                                             true  => $_[3],
                                             false => $_[5],
                                     )
                                   }
	],
	[#Rule 123
		 'ConditionalExpressionNoIn', 1, undef
	],
	[#Rule 124
		 'ConditionalExpressionNoIn', 5,
sub
#line 470 "lib/Javascript/Grammar.yp"
{ bless [  LogicalORExpression => $_[1],
                                        true  => $_[3],
                                        false => $_[5],
                                      ], 'ConditionalExpression'
                              }
	],
	[#Rule 125
		 'ConditionalExpression', 1, undef
	],
	[#Rule 126
		 'ConditionalExpression', 5,
sub
#line 480 "lib/Javascript/Grammar.yp"
{ bless [  LogicalORExpression => $_[1],
                                    true  => $_[3],
                                    false => $_[5],
                                  ], 'ConditionalExpression'
                          }
	],
	[#Rule 127
		 'PostfixOperator', 1,
sub
#line 488 "lib/Javascript/Grammar.yp"
{ value $_[1], 'PostfixOperator' }
	],
	[#Rule 128
		 'PostfixOperator', 1,
sub
#line 489 "lib/Javascript/Grammar.yp"
{ value $_[1], 'PostfixOperator' }
	],
	[#Rule 129
		 'PostfixExpression_no_func_lc', 1, undef
	],
	[#Rule 130
		 'PostfixExpression_no_func_lc', 2,
sub
#line 495 "lib/Javascript/Grammar.yp"
{ bless [  LeftHandSideExpression => $_[1], Operator => $_[2] ], 'PostfixExpression' }
	],
	[#Rule 131
		 'PostfixExpression', 1, undef
	],
	[#Rule 132
		 'PostfixExpression', 2,
sub
#line 500 "lib/Javascript/Grammar.yp"
{ bless [  LeftHandSideExpression => $_[1], Operator => $_[2] ], 'PostfixExpression' }
	],
	[#Rule 133
		 'UnaryPrefixOperator', 1,
sub
#line 504 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 134
		 'UnaryPrefixOperator', 1,
sub
#line 505 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 135
		 'UnaryPrefixOperator', 1,
sub
#line 506 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 136
		 'UnaryPrefixOperator', 1,
sub
#line 507 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 137
		 'UnaryPrefixOperator', 1,
sub
#line 508 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 138
		 'UnaryPrefixOperator', 1,
sub
#line 509 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 139
		 'UnaryPrefixOperator', 1,
sub
#line 510 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 140
		 'UnaryPrefixOperator', 1,
sub
#line 511 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 141
		 'UnaryPrefixOperator', 1,
sub
#line 512 "lib/Javascript/Grammar.yp"
{ value $_[1], 'UnaryPrefixOperator' }
	],
	[#Rule 142
		 'UnaryExpression_no_func_lc', 1, undef
	],
	[#Rule 143
		 'UnaryExpression_no_func_lc', 2,
sub
#line 518 "lib/Javascript/Grammar.yp"
{ bless [  UnaryPrefixOperator => $_[1], UnaryExpression => $_[2] ], 'UnaryExpression' }
	],
	[#Rule 144
		 'UnaryExpression', 1, undef
	],
	[#Rule 145
		 'UnaryExpression', 2,
sub
#line 523 "lib/Javascript/Grammar.yp"
{ bless [  UnaryPrefixOperator => $_[1], UnaryExpression => $_[2] ], 'UnaryExpression' }
	],
	[#Rule 146
		 'MultiplicativeOperator', 1,
sub
#line 527 "lib/Javascript/Grammar.yp"
{ value $_[1], 'MultiplicativeOperator' }
	],
	[#Rule 147
		 'MultiplicativeOperator', 1,
sub
#line 528 "lib/Javascript/Grammar.yp"
{ value $_[1], 'MultiplicativeOperator' }
	],
	[#Rule 148
		 'MultiplicativeOperator', 1,
sub
#line 529 "lib/Javascript/Grammar.yp"
{ value $_[1], 'MultiplicativeOperator' }
	],
	[#Rule 149
		 'MultiplicativeExpression_no_func_lc', 1, undef
	],
	[#Rule 150
		 'MultiplicativeExpression_no_func_lc', 3,
sub
#line 535 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], Operator => $_[2], rhs => $_[3] ], 'MultiplicativeExpression' }
	],
	[#Rule 151
		 'MultiplicativeExpression', 1, undef
	],
	[#Rule 152
		 'MultiplicativeExpression', 3,
sub
#line 541 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], Operator => $_[2], rhs => $_[3] ], 'MultiplicativeExpression' }
	],
	[#Rule 153
		 'AdditiveOperator', 1,
sub
#line 545 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AdditiveOperator' }
	],
	[#Rule 154
		 'AdditiveOperator', 1,
sub
#line 546 "lib/Javascript/Grammar.yp"
{ value $_[1], 'AdditiveOperator' }
	],
	[#Rule 155
		 'AdditiveExpression_no_func_lc', 1, undef
	],
	[#Rule 156
		 'AdditiveExpression_no_func_lc', 3,
sub
#line 552 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], Operator => $_[2], rhs => $_[3] ], 'AdditiveExpression' }
	],
	[#Rule 157
		 'AdditiveExpression', 1, undef
	],
	[#Rule 158
		 'AdditiveExpression', 3,
sub
#line 558 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], Operator => $_[2], rhs => $_[3] ], 'AdditiveExpression' }
	],
	[#Rule 159
		 'ShiftOperator', 1,
sub
#line 562 "lib/Javascript/Grammar.yp"
{ value $_[1], 'ShiftOperator' }
	],
	[#Rule 160
		 'ShiftOperator', 1,
sub
#line 563 "lib/Javascript/Grammar.yp"
{ value $_[1], 'ShiftOperator' }
	],
	[#Rule 161
		 'ShiftOperator', 1,
sub
#line 564 "lib/Javascript/Grammar.yp"
{ value $_[1], 'ShiftOperator' }
	],
	[#Rule 162
		 'ShiftExpression_no_func_lc', 1, undef
	],
	[#Rule 163
		 'ShiftExpression_no_func_lc', 3,
sub
#line 569 "lib/Javascript/Grammar.yp"
{ bless [  ShiftExpression => $_[1],
                                       ShiftOperator => $_[2],
                                       ShiftCount => $_[3] ], 'ShiftExpression' }
	],
	[#Rule 164
		 'ShiftExpression', 1, undef
	],
	[#Rule 165
		 'ShiftExpression', 3,
sub
#line 576 "lib/Javascript/Grammar.yp"
{ bless [  ShiftExpression => $_[1],
                                                                             ShiftOperator => $_[2],
                                                                             ShiftCount => $_[3] ], 'ShiftExpression' }
	],
	[#Rule 166
		 'RelationalOperatorNoIn', 1,
sub
#line 582 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RelationalOperator' }
	],
	[#Rule 167
		 'RelationalOperatorNoIn', 1,
sub
#line 583 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RelationalOperator' }
	],
	[#Rule 168
		 'RelationalOperatorNoIn', 1,
sub
#line 584 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RelationalOperator' }
	],
	[#Rule 169
		 'RelationalOperatorNoIn', 1,
sub
#line 585 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RelationalOperator' }
	],
	[#Rule 170
		 'RelationalOperatorNoIn', 1,
sub
#line 586 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RelationalOperator' }
	],
	[#Rule 171
		 'RelationalOperator', 1, undef
	],
	[#Rule 172
		 'RelationalOperator', 1,
sub
#line 591 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RelationalOperator' }
	],
	[#Rule 173
		 'RelationalExpression_no_func_lc', 1, undef
	],
	[#Rule 174
		 'RelationalExpression_no_func_lc', 3,
sub
#line 597 "lib/Javascript/Grammar.yp"
{ bless [  lhs      => $_[1],
                                            Operator => $_[2],
                                            rhs      => $_[3] ], 'RelationalExpression' }
	],
	[#Rule 175
		 'RelationalExpressionNoIn', 1, undef
	],
	[#Rule 176
		 'RelationalExpressionNoIn', 3,
sub
#line 605 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], Operator => $_[2], rhs => $_[3] ], 'RelationalExpression' }
	],
	[#Rule 177
		 'RelationalExpression', 1, undef
	],
	[#Rule 178
		 'RelationalExpression', 3,
sub
#line 610 "lib/Javascript/Grammar.yp"
{ bless [  lhs      => $_[1],
                                                                                         Operator => $_[2],
                                                                                         rhs      => $_[3] ], 'RelationalExpression' }
	],
	[#Rule 179
		 'EqualityOperator', 1,
sub
#line 616 "lib/Javascript/Grammar.yp"
{ value $_[1],'EqualityOperator' }
	],
	[#Rule 180
		 'EqualityOperator', 1,
sub
#line 617 "lib/Javascript/Grammar.yp"
{ value $_[1],'EqualityOperator' }
	],
	[#Rule 181
		 'EqualityOperator', 1,
sub
#line 618 "lib/Javascript/Grammar.yp"
{ value $_[1],'EqualityOperator' }
	],
	[#Rule 182
		 'EqualityOperator', 1,
sub
#line 619 "lib/Javascript/Grammar.yp"
{ value $_[1],'EqualityOperator' }
	],
	[#Rule 183
		 'EqualityExpression_no_func_lc', 1, undef
	],
	[#Rule 184
		 'EqualityExpression_no_func_lc', 3,
sub
#line 625 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1],
                                          Operator => $_[2],
                                          rhs => $_[3] ], 'EqualityExpression' }
	],
	[#Rule 185
		 'EqualityExpressionNoIn', 1, undef
	],
	[#Rule 186
		 'EqualityExpressionNoIn', 3,
sub
#line 633 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], Operator => $_[2], rhs => $_[3] ], 'EqualityExpression' }
	],
	[#Rule 187
		 'EqualityExpression', 1, undef
	],
	[#Rule 188
		 'EqualityExpression', 3,
sub
#line 638 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1],
                                                                                        Operator => $_[2],
                                                                                        rhs => $_[3] ], 'EqualityExpression' }
	],
	[#Rule 189
		 'BitwiseANDExpression_no_func_lc', 1, undef
	],
	[#Rule 190
		 'BitwiseANDExpression_no_func_lc', 3,
sub
#line 646 "lib/Javascript/Grammar.yp"
{ bless [  lhs      => $_[1],
                                            rhs      => $_[3] ], 'BitwiseANDExpression' }
	],
	[#Rule 191
		 'BitwiseANDExpressionNoIn', 1, undef
	],
	[#Rule 192
		 'BitwiseANDExpressionNoIn', 3,
sub
#line 653 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseANDExpression' }
	],
	[#Rule 193
		 'BitwiseANDExpression', 1, undef
	],
	[#Rule 194
		 'BitwiseANDExpression', 3,
sub
#line 658 "lib/Javascript/Grammar.yp"
{ bless [  lhs      => $_[1],
                                                                             rhs      => $_[3] ], 'BitwiseANDExpression' }
	],
	[#Rule 195
		 'BitwiseXORExpression_no_func_lc', 1, undef
	],
	[#Rule 196
		 'BitwiseXORExpression_no_func_lc', 3,
sub
#line 665 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseXORExpression' }
	],
	[#Rule 197
		 'BitwiseXORExpressionNoIn', 1, undef
	],
	[#Rule 198
		 'BitwiseXORExpressionNoIn', 3,
sub
#line 672 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseXORExpression' }
	],
	[#Rule 199
		 'BitwiseXORExpression', 1, undef
	],
	[#Rule 200
		 'BitwiseXORExpression', 3,
sub
#line 677 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseXORExpression' }
	],
	[#Rule 201
		 'BitwiseORExpression_no_func_lc', 1, undef
	],
	[#Rule 202
		 'BitwiseORExpression_no_func_lc', 3,
sub
#line 683 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseORExpression' }
	],
	[#Rule 203
		 'BitwiseORExpressionNoIn', 1, undef
	],
	[#Rule 204
		 'BitwiseORExpressionNoIn', 3,
sub
#line 689 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseORExpression' }
	],
	[#Rule 205
		 'BitwiseORExpression', 1, undef
	],
	[#Rule 206
		 'BitwiseORExpression', 3,
sub
#line 695 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'BitwiseORExpression' }
	],
	[#Rule 207
		 'LogicalANDExpression_no_func_lc', 1, undef
	],
	[#Rule 208
		 'LogicalANDExpression_no_func_lc', 3,
sub
#line 701 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'LogicalANDExpression' }
	],
	[#Rule 209
		 'LogicalANDExpressionNoIn', 1, undef
	],
	[#Rule 210
		 'LogicalANDExpressionNoIn', 3,
sub
#line 707 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1], rhs => $_[3] ], 'LogicalANDExpression' }
	],
	[#Rule 211
		 'LogicalANDExpression', 1, undef
	],
	[#Rule 212
		 'LogicalANDExpression', 3,
sub
#line 712 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1],
                                                                               rhs => $_[3] ], 'LogicalANDExpression' }
	],
	[#Rule 213
		 'LogicalORExpression_no_func_lc', 1, undef
	],
	[#Rule 214
		 'LogicalORExpression_no_func_lc', 3,
sub
#line 719 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1],
                                             rhs => $_[3] ], 'LogicalORExpression' }
	],
	[#Rule 215
		 'LogicalORExpressionNoIn', 1, undef
	],
	[#Rule 216
		 'LogicalORExpressionNoIn', 3,
sub
#line 725 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1],
                                                                                  rhs => $_[3] ], 'LogicalORExpression' }
	],
	[#Rule 217
		 'LogicalORExpression', 1, undef
	],
	[#Rule 218
		 'LogicalORExpression', 3,
sub
#line 731 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[1],
                                                                              rhs => $_[3] ], 'LogicalORExpression' }
	],
	[#Rule 219
		 'OptionalStatementList', 1, undef
	],
	[#Rule 220
		 'OptionalStatementList', 0,
sub
#line 736 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [] ], 'StatementList' }
	],
	[#Rule 221
		 'StatementList', 1,
sub
#line 739 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [ $_[1] ]], 'StatementList' }
	],
	[#Rule 222
		 'StatementList', 2,
sub
#line 740 "lib/Javascript/Grammar.yp"
{ $_[2]->prepend( $_[1] ) }
	],
	[#Rule 223
		 'Statement', 1,
sub
#line 743 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 224
		 'Statement', 1,
sub
#line 744 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 225
		 'Statement', 1,
sub
#line 745 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 226
		 'Statement', 1,
sub
#line 746 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 227
		 'Statement', 1,
sub
#line 747 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 228
		 'Statement', 1,
sub
#line 748 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 229
		 'Statement', 1,
sub
#line 749 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 230
		 'Statement', 1,
sub
#line 750 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 231
		 'Statement', 1,
sub
#line 751 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 232
		 'Statement', 1,
sub
#line 752 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 233
		 'Statement', 1,
sub
#line 753 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 234
		 'Statement', 1,
sub
#line 754 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 235
		 'Statement', 1,
sub
#line 755 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 236
		 'Statement', 1,
sub
#line 756 "lib/Javascript/Grammar.yp"
{ bless [  ref $_[1] => $_[1] ], 'Statement' }
	],
	[#Rule 237
		 'Block', 2,
sub
#line 760 "lib/Javascript/Grammar.yp"
{ bless [  ], 'Block' }
	],
	[#Rule 238
		 'Block', 3,
sub
#line 761 "lib/Javascript/Grammar.yp"
{ bless [  StatementList => $_[2] ], 'Block' }
	],
	[#Rule 239
		 'VariableStatement', 3,
sub
#line 766 "lib/Javascript/Grammar.yp"
{
  bless [  VariableDeclarationList => $_[2] ], 'VariableStatement'
}
	],
	[#Rule 240
		 'ExpressionStatement', 2,
sub
#line 770 "lib/Javascript/Grammar.yp"
{ bless [  Expression => $_[1] ], 'ExpressionStatement' }
	],
	[#Rule 241
		 'VariableDeclarationListNoIn', 1,
sub
#line 775 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [ $_[1] ] ], 'VariableDeclarationList' }
	],
	[#Rule 242
		 'VariableDeclarationListNoIn', 3,
sub
#line 777 "lib/Javascript/Grammar.yp"
{ $_[3]->prepend( $_[1] ) }
	],
	[#Rule 243
		 'VariableDeclarationList', 1,
sub
#line 781 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [ $_[1] ] ], 'VariableDeclarationList' }
	],
	[#Rule 244
		 'VariableDeclarationList', 3,
sub
#line 782 "lib/Javascript/Grammar.yp"
{ $_[3]->prepend( $_[1] ) }
	],
	[#Rule 245
		 'VariableDeclarationNoIn', 2,
sub
#line 786 "lib/Javascript/Grammar.yp"
{ bless [  Identifier => $_[1], Initializer => $_[2] ], 'VariableDeclaration' }
	],
	[#Rule 246
		 'VariableDeclarationNoIn', 1,
sub
#line 787 "lib/Javascript/Grammar.yp"
{ bless [  Identifier => $_[1] ], 'VariableDeclaration' }
	],
	[#Rule 247
		 'VariableDeclaration', 2,
sub
#line 791 "lib/Javascript/Grammar.yp"
{ bless [  Identifier => $_[1], Initializer => $_[2] ], 'VariableDeclaration' }
	],
	[#Rule 248
		 'VariableDeclaration', 1,
sub
#line 792 "lib/Javascript/Grammar.yp"
{ bless [  Identifier => $_[1] ], 'VariableDeclaration' }
	],
	[#Rule 249
		 'InitializerNoIn', 2,
sub
#line 796 "lib/Javascript/Grammar.yp"
{ bless [  AssignmentExpression => $_[2] ], 'Initializer' }
	],
	[#Rule 250
		 'Initializer', 2,
sub
#line 799 "lib/Javascript/Grammar.yp"
{ bless [  AssignmentExpression => $_[2] ], 'Initializer' }
	],
	[#Rule 251
		 'EmptyStatement', 1,
sub
#line 803 "lib/Javascript/Grammar.yp"
{ bless [ ], 'EmptyStatement' }
	],
	[#Rule 252
		 'IfStatement', 7,
sub
#line 808 "lib/Javascript/Grammar.yp"
{ bless [  Expression => $_[3], true => $_[5], false => $_[7] ], 'IfStatement' }
	],
	[#Rule 253
		 'IfStatement', 5,
sub
#line 809 "lib/Javascript/Grammar.yp"
{ bless [  Expression => $_[3], true => $_[5]                 ], 'IfStatement' }
	],
	[#Rule 254
		 'DoStatement', 7,
sub
#line 816 "lib/Javascript/Grammar.yp"
{ bless [  Statement => $_[2], Expression => $_[5] ], 'DoStatement'}
	],
	[#Rule 255
		 'WhileStatement', 5,
sub
#line 821 "lib/Javascript/Grammar.yp"
{ bless [  Statement => $_[5], Expression => $_[3] ], 'WhileStatement'}
	],
	[#Rule 256
		 'EmptyExpression', 0,
sub
#line 824 "lib/Javascript/Grammar.yp"
{ bless [ ], 'EmptyExpression' }
	],
	[#Rule 257
		 'OptionalExpressionNoIn', 1, undef
	],
	[#Rule 258
		 'OptionalExpressionNoIn', 1, undef
	],
	[#Rule 259
		 'OptionalExpression', 1, undef
	],
	[#Rule 260
		 'OptionalExpression', 1, undef
	],
	[#Rule 261
		 'CForStatement', 9,
sub
#line 839 "lib/Javascript/Grammar.yp"
{ bless [  InitExpression => $_[3], Incrementor => $_[5], Condition => $_[7], Statement => $_[9] ], 'CForStatement'}
	],
	[#Rule 262
		 'CForStatement', 10,
sub
#line 841 "lib/Javascript/Grammar.yp"
{ bless [  InitExpression => $_[4], Condition => $_[6], Incrementor => $_[8], Statement => $_[10] ], 'CForStatement'}
	],
	[#Rule 263
		 'ForInStatement', 7,
sub
#line 846 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[3], list => $_[5], Statement => $_[7] ], 'ForInStatement'}
	],
	[#Rule 264
		 'ForInStatement', 8,
sub
#line 848 "lib/Javascript/Grammar.yp"
{ bless [  lhs => $_[4], list => $_[6], Statement => $_[8] ], 'ForInStatement'}
	],
	[#Rule 265
		 'IterationStatement', 1, undef
	],
	[#Rule 266
		 'IterationStatement', 1, undef
	],
	[#Rule 267
		 'IterationStatement', 1, undef
	],
	[#Rule 268
		 'IterationStatement', 1, undef
	],
	[#Rule 269
		 'ContinueStatement', 3,
sub
#line 859 "lib/Javascript/Grammar.yp"
{ bless [  Identifier => $_[2] ], 'ContinueStatement' }
	],
	[#Rule 270
		 'BreakStatement', 3,
sub
#line 864 "lib/Javascript/Grammar.yp"
{ bless [  Identifier => $_[2] ], 'BreakStatement' }
	],
	[#Rule 271
		 'ReturnStatement', 3,
sub
#line 869 "lib/Javascript/Grammar.yp"
{ bless [  Result => $_[2] ], 'ReturnStatement' }
	],
	[#Rule 272
		 'WithStatement', 5,
sub
#line 874 "lib/Javascript/Grammar.yp"
{ bless [  WithExpression => $_[3], Statement => $_[5] ], 'WithStatement' }
	],
	[#Rule 273
		 'SwitchStatement', 5,
sub
#line 879 "lib/Javascript/Grammar.yp"
{ bless [  Expression => $_[3], Cases => $_[5] ], 'SwitchStatement' }
	],
	[#Rule 274
		 'CaseBlock', 3,
sub
#line 884 "lib/Javascript/Grammar.yp"
{ $_[2] }
	],
	[#Rule 275
		 'CaseBlock', 5,
sub
#line 886 "lib/Javascript/Grammar.yp"
{ my $result = $_[2];
              $result->append( $_[3] );
              $result->append( $_ ) for ($_[4]->ELEMENTS);
              $result
            }
	],
	[#Rule 276
		 'OptionalCaseClauses', 0,
sub
#line 894 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [] ], 'CaseClauses' }
	],
	[#Rule 277
		 'OptionalCaseClauses', 1, undef
	],
	[#Rule 278
		 'CaseClauses', 1,
sub
#line 899 "lib/Javascript/Grammar.yp"
{ bless [  __ELEMENTS__ => [ $_[1] ] ], 'CaseClauses' }
	],
	[#Rule 279
		 'CaseClauses', 2,
sub
#line 900 "lib/Javascript/Grammar.yp"
{ $_[1]->append( $_[2] ) }
	],
	[#Rule 280
		 'CaseClause', 4,
sub
#line 905 "lib/Javascript/Grammar.yp"
{ CaseClause( Expression => $_[2], Statements => $_[4] ) }
	],
	[#Rule 281
		 'DefaultClause', 3,
sub
#line 910 "lib/Javascript/Grammar.yp"
{ DefaultClause( Statements => $_[3] ) }
	],
	[#Rule 282
		 'LabelledStatement', 3,
sub
#line 914 "lib/Javascript/Grammar.yp"
{ LabelledStatement( Label => $_[1], Statement => $_[3] ) }
	],
	[#Rule 283
		 'ThrowStatement', 3,
sub
#line 919 "lib/Javascript/Grammar.yp"
{ ThrowStatement( Expression => $_[2] ) }
	],
	[#Rule 284
		 'TryStatement', 4,
sub
#line 924 "lib/Javascript/Grammar.yp"
{ TryStatement( Block => $_[2], Catch => $_[3], Finally => $_[4] ) }
	],
	[#Rule 285
		 'OptionalCatch', 1, undef
	],
	[#Rule 286
		 'OptionalCatch', 0,
sub
#line 929 "lib/Javascript/Grammar.yp"
{ Catch() }
	],
	[#Rule 287
		 'Catch', 5,
sub
#line 934 "lib/Javascript/Grammar.yp"
{ Catch( Identifier => $_[3], Block => $_[5] ) }
	],
	[#Rule 288
		 'OptionalFinally', 1, undef
	],
	[#Rule 289
		 'OptionalFinally', 0,
sub
#line 939 "lib/Javascript/Grammar.yp"
{ Finally() }
	],
	[#Rule 290
		 'Finally', 2,
sub
#line 944 "lib/Javascript/Grammar.yp"
{ Finally( Block => $_[2] ) }
	],
	[#Rule 291
		 'OptionalIdentifier', 0,
sub
#line 947 "lib/Javascript/Grammar.yp"
{ bless [ ], 'OptionalIdentifier' }
	],
	[#Rule 292
		 'OptionalIdentifier', 1, undef
	],
	[#Rule 293
		 'Identifier', 1,
sub
#line 951 "lib/Javascript/Grammar.yp"
{ value $_[1], 'Identifier' }
	],
	[#Rule 294
		 'Number', 1,
sub
#line 954 "lib/Javascript/Grammar.yp"
{ value $_[1], 'Number' }
	],
	[#Rule 295
		 'String', 1,
sub
#line 955 "lib/Javascript/Grammar.yp"
{ value $_[1], 'String' }
	],
	[#Rule 296
		 'Boolean', 1,
sub
#line 956 "lib/Javascript/Grammar.yp"
{ value $_[1], 'Boolean' }
	],
	[#Rule 297
		 'Null', 1,
sub
#line 957 "lib/Javascript/Grammar.yp"
{ value $_[1], 'Null' }
	],
	[#Rule 298
		 'RegularExpressionLiteral', 1,
sub
#line 960 "lib/Javascript/Grammar.yp"
{ value $_[1], 'RegularExpressionLiteral' }
	]
],
                                  @_);
    bless($self,$class);
}

#line 1007 "lib/Javascript/Grammar.yp"


=for later
=cut

my @symbols = (qw(
 *= /= %= += -= <<= >>= >>>= &= ^= |=

 === == !== !=
 <= >=

 ; ++ + -- - { } \( \)

 ! ~ ^

 =

 / * %

 && &
 || |

 ? :

 [ ]

 .

 >>> >> >
 <<< << <
), ',');

my @keywords = qw(
  break
  case
  catch
  continue
  default
  delete
  do
  else
  finally
  for
  function
  if
  instanceof
  in
  new
  return
  switch
  throw
  try
  typeof
  var
  void
  while
  with
);

use vars qw($re_single_quote $re_double_quote
            $re_decimal_number $re_hexadecimal_number
           );
BEGIN {
  $re_single_quote = gen_delimited_pat("'");
  $re_double_quote = gen_delimited_pat('"');
  $re_decimal_number = $RE{num}{real}{-keep};
  $re_hexadecimal_number = qr/0x$RE{num}{real}{-base => 16}{-keep}/i;
};

sub yylex {
  my ($self) = @_;
  my ($code) = \($self->YYData->{code});

  my $pos;
  NEWLINE: {
    # skip whitespace
    $$code =~ m/\G\s*/csmg;
    $pos = pos $$code;

    # single line comments
    $$code =~ m!\G//[^\n]*[\r\n]+!csmg
      and redo NEWLINE;
    $pos = pos $$code;

    # C-style comments
    $$code =~ m'\G/\*          # Start the comment with "/*"
                                (?:
                                   [^*/]*    # then any characters except "*" and "/"
                                  |[*](?!/)  # or "*" unless it is followed by a "/"
                                  |[/]       # or a single slash
                                )
                                *\*/         # and close the comment
                              'csmgx
      and redo NEWLINE;
  }

  # Numbers: Hexadecimal, decimal, infinity
  for (qw(+ -)) {
    return ($_,$_)
      if $$code =~ m/\G\Q$_\E(?=[0-9])/cg;
  };

  return ('NUMBER',0+hex $1) if $$code =~ m/\G(?!\.[^0-9])$re_hexadecimal_number/cg;
  return ('NUMBER',0+$1) if $$code =~ m/\G(?!\.[^0-9])$re_decimal_number/cg;

  # weird literals
  return ('NUMBER','Infinity') if $$code =~ m/\GInfinity\b/cg;
  return ('BOOLEAN',1) if $$code =~ m/\Gtrue\b/cg;
  return ('BOOLEAN',0) if $$code =~ m/\Gfalse\b/cg;
  return ('NULL','null') if $$code =~ m/\Gnull\b/cg;

  # if a regex is allowed to follow, check for it:
  if (grep { $_ eq 'REGEX' } ($self->YYExpect)) {
    if ($$code =~ m'\G
                    /                  # leading slash
                    (
                         (?!\s)        # a JS regex can never start with a blank ...
                         [^\\/]+       # no slash
                        |[\\]([^\\/])  # escape sequence
                        |[\\][\\]      # quoted backslash
                        |[\\][/]       # quoted slash
                    )
                    /
                    (\w*)
                    'gcx) {
      my ($re,$flags) = ($1,$2);
      # clean up $re for quoted stuff etc.
      # TODO
      # convert it into a compiled regex object:
      $flags ||= "";
      $re = qr((?:$flags)(?:$re));
      #warn "Found regex literal $re";
      return ('REGEX',$re);
    };
  };

  for my $reserved (@symbols) {
    return ($reserved,$reserved) if $$code =~ m/\G\Q$reserved\E/cg;
  };

  for my $reserved (@keywords) {
    return ($reserved,$reserved) if $$code =~ m/\G\Q$reserved\E\b/cg;
  };

  return ('IDENTIFIER',$1) if $$code =~ m/\G([A-Za-z_]\w*)/cg;

  if (  $$code =~ m!\G($re_single_quote)!cg
     or $$code =~ m!\G($re_double_quote)!cg) {
    my $value = substr $1, 1;
    chop $value;
    return ('STRING', $value);
  };

  return ('', undef) if pos $$code == length $$code;
  die sprintf "Unknown token: '%s'", $$code;
};

1;
__END__

=head1 SEE ALSO

L<Javascript::PurePerl>,L<Parse::Yapp>,L<Parse::RecDescent>, L<Javascript>

=head1 AUTHOR

Max Maischein E<lt>corion@cpan.orgE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2003,2004 by Max Maischein

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.2 or,
at your option, any later version of Perl 5 you may have available.

=cut

1;
